import sys
import numpy as np
import os
import h5py
import numpy as np
from glob import glob
import matplotlib.pyplot as plt
from sklearn.metrics import roc_auc_score
import pandas as pd

# run_on_rhino = True
run_on_rhino = False

if run_on_rhino:
    num_mp_procs = 0
    rhino_mount = ''
else:
    num_mp_procs = 0
    rhino_mount = '/home/ctw/fusemounts/rhino'
homedir = rhino_mount+'/scratch/cweidema/LTP/ltpFR2'

regressorfolder_name = 'ridge_nestedXval_logit'
regressor_folder = (os.path.join(
    homedir, 'ltpFR2_regressors/listvar/',
    regressorfolder_name, 'hdf5_files'))

regfiles = np.sort(glob(os.path.join(regressor_folder, 'regressor_info_allfeat_LTP???.hdf5')))

with h5py.File(regfiles[0], 'r') as regfile:
    recallability_within_df = pd.DataFrame(index=np.array(
        np.unique(regfile['events/item']), dtype=np.str))

for rf in regfiles:
    with h5py.File(rf, 'r') as regfile:
        assert(len(np.unique(regfile['events/subject']))==1)
        subj = regfile['events/subject'][0]
        rec_dtypes = [(str(e), regfile['events'][e].dtype) for e in regfile['events']]
        evarray = np.zeros(regfile['events/subject'].shape, rec_dtypes)
        for ev_val in regfile['events']:
            evarray[ev_val] = regfile['events'][ev_val]
        evdf = pd.DataFrame(evarray)
        recallability_within_df[subj] = np.array(
            [np.mean(evdf[evdf['item'] == word]['recalled'])
             for word in recallability_within_df.index])

recallability_heldout_df = pd.DataFrame(index=recallability_within_df.index)
for subj in recallability_within_df:
    recallability_heldout_df[subj] = np.mean(
        recallability_within_df.loc[
            :, recallability_within_df.columns != subj], 1)



