# import sys
import numpy as np
import scipy as sp
import os
import h5py
import numpy as np
from glob import glob
import io
import pickle
import h5py
import numpy.ma as ma
import matplotlib.pyplot as plt
import matplotlib.gridspec as gridspec
import scipy.stats as stats
# import matplotlib.patches as mpatches
# from sklearn.metrics import roc_auc_score
# from scipy.io import loadmat
# from pandas import read_table
# import pandas as pd
# import xarray as xr
# import seaborn as sns
# from scipy.stats import ttest_rel, ttest_1samp

# from ptsa.data.timeseries import TimeSeries

import matplotlib as mpl
mpl.rcParams['pdf.fonttype'] = 42
mpl.rcParams['ps.fonttype'] = 42

SHUFFLES = 20

# run_on_rhino = True
run_on_rhino = False
homedir = None
# homedir = '/media/ctw/intbkup1/rhino_eeg/LTP/ltpFR2'
# homedir = '/home/ctw/fusemounts/swan/media/ctw/intbkup1/rhino_eeg/LTP/ltpFR2'

if run_on_rhino:
    num_mp_procs = 0
    rhino_mount = ''
else:
    num_mp_procs = 0
    rhino_mount = '/home/ctw/fusemounts/rhino'
if homedir is None:
    homedir = rhino_mount+'/scratch/cweidema/LTP/ltpFR2'

processed_subjdat_folder = os.path.join(
    rhino_mount+'/scratch/cweidema/LTP/ltpFR2/ltpFR2_processed/subj_hdf5/')

processed_files = sorted(glob(processed_subjdat_folder+'LTP???_procpowdat.hdf5'))

# # dat_all_dict = {'subject': [], 'recalled': [], 'unrecalled': [],
# #                 'recalled_logit': {i: [] for i in range(4)},
# #                 'residuals_interlist':  {i: [] for i in range(4)},
# #                 'residuals_intersess':  {i: [] for i in range(4)}
# # }


# # # processed_file = processed_files[0]

# # for processed_file in processed_files:
# #     pf = h5py.File(processed_file, 'r')
# #     subj = processed_file.split('/')[-1].split('_')[0]
# #     print(subj)
# #     dat_all_dict['subject'].append(subj.encode())
# #     dat_all_dict['unrecalled'].append(
# #         ma.array(pf['data'], mask=np.broadcast_to(np.bool8(pf['recalled'][:])[
# #             :, :, np.newaxis, :, np.newaxis], pf['data'].shape)).mean(
# #                 -2).mean(1).mean(0))
# #     dat_all_dict['recalled'].append(
# #         ma.array(pf['data'], mask=~np.broadcast_to(np.bool8(pf['recalled'][:])[
# #             :, :, np.newaxis, :, np.newaxis], pf['data'].shape)).mean(
# #                 -2).mean(1).mean(0))
# #     quartiles_thresh = {
# #         'recalled_logit': np.nanpercentile(
# #             np.ravel(pf['recalled_logit']), [0, 25, 50, 75, 100]),
# #         'residuals_interlist': np.nanpercentile(
# #             np.ravel(pf['residuals_interlist']), [0, 25, 50, 75, 100]),
# #         'residuals_intersess': np.nanpercentile(
# #             np.ravel(pf['residuals_intersess']), [0, 25, 50, 75, 100])
# #     }
# #     for dv in quartiles_thresh:
# #         for i, thresh in enumerate(quartiles_thresh[dv][:-1]):
# #                 dat_all_dict[dv][i].append(
# #                     ma.array(pf['data'], mask=np.broadcast_to(
# #                         ((pf[dv][:]<thresh) | (pf[dv][:]>=quartiles_thresh[dv][
# #                             i+1]))[:, :, np.newaxis, np.newaxis, np.newaxis],
# #                         pf['data'].shape)).mean(-2).mean(1).mean(0))

# # dat_all = h5py.File('processed_dat/dat_all.hdf5', 'x')
# # for key1 in dat_all_dict:
# #     if isinstance(dat_all_dict[key1], dict):
# #         for key2  in dat_all_dict[key1]:
# #             if isinstance(dat_all_dict[key1][key2], dict):
# #                 for key3  in dat_all_dict[key1][key2]:
# #                     dat_all2.create_dataset(
# #                         str(key1)+'/'+str(key2)+'/'+str(key3), data=dat_all_dict[key1][key2][key3],
# #                         compression='gzip', compression_opts=9)
# #             else:
# #                 dat_all2.create_dataset(
# #                     str(key1)+'/'+str(key2), data=dat_all_dict[key1][key2],
# #                     compression='gzip', compression_opts=9)
# #     else:
# #         dat_all2.create_dataset(
# #             str(key1), data=dat_all_dict[key1],
# #             compression='gzip', compression_opts=9)




# # dat_all_dict = {'subject': [], 'recalled': [], 'unrecalled': [],
# #                 'recalled_logit': {'recalled': {i: [] for i in range(4)},
# #                                    'unrecalled': {i: [] for i in range(4)},
# #                                    'all': {i: [] for i in range(4)}},
# #                 'residuals_interlist': {
# #                     'recalled': {i: [] for i in range(4)},
# #                     'unrecalled': {i: [] for i in range(4)},
# #                     'all': {i: [] for i in range(4)}},
# #                 'residuals_intersess': {
# #                     'recalled': {i: [] for i in range(4)},
# #                     'unrecalled': {i: [] for i in range(4)},
# #                     'all': {i: [] for i in range(4)}}}

# # for processed_file in processed_files:
# #     pf = h5py.File(processed_file, 'r')
# #     subj = processed_file.split('/')[-1].split('_')[0]
# #     print(subj)
# #     dat_all_dict['subject'].append(subj.encode())
# #     rec_mask = ~np.broadcast_to(np.bool8(pf['recalled'][:])[
# #         :, :, np.newaxis, :, np.newaxis], pf['data'].shape)
# #     unrec_mask = np.broadcast_to(np.bool8(pf['recalled'][:])[
# #         :, :, np.newaxis, :, np.newaxis], pf['data'].shape)
# #     dat_all_dict['unrecalled'].append(
# #         ma.array(pf['data'], mask=unrec_mask).mean(-2).mean(1).mean(0))
# #     dat_all_dict['recalled'].append(
# #         ma.array(pf['data'], mask=rec_mask).mean(-2).mean(1).mean(0))
# #     quartiles_thresh = {
# #         'recalled_logit': np.nanpercentile(
# #             np.ravel(pf['recalled_logit']), [0, 25, 50, 75, 100]),
# #         'residuals_interlist': np.nanpercentile(
# #             np.ravel(pf['residuals_interlist']), [0, 25, 50, 75, 100]),
# #         'residuals_intersess': np.nanpercentile(
# #             np.ravel(pf['residuals_intersess']), [0, 25, 50, 75, 100])
# #     }
# #     for dv in quartiles_thresh:
# #         for i, thresh in enumerate(quartiles_thresh[dv][:-1]):
# #                 dat_all_dict[dv]['all'][i].append(
# #                     ma.array(pf['data'], mask=np.broadcast_to(
# #                         ((pf[dv][:]<thresh) | (pf[dv][:]>=quartiles_thresh[dv][
# #                             i+1]))[:, :, np.newaxis, np.newaxis, np.newaxis],
# #                         pf['data'].shape)).mean(-2).mean(1).mean(0))
# #                 dat_all_dict[dv]['recalled'][i].append(
# #                     ma.array(pf['data'], mask=rec_mask & np.broadcast_to(
# #                         ((pf[dv][:]<thresh) | (pf[dv][:]>=quartiles_thresh[dv][
# #                             i+1]))[:, :, np.newaxis, np.newaxis, np.newaxis],
# #                         pf['data'].shape)).mean(-2).mean(1).mean(0))
# #                 dat_all_dict[dv]['unrecalled'][i].append(
# #                     ma.array(pf['data'], mask=unrec_mask & np.broadcast_to(
# #                         ((pf[dv][:]<thresh) | (pf[dv][:]>=quartiles_thresh[dv][
# #                             i+1]))[:, :, np.newaxis, np.newaxis, np.newaxis],
# #                         pf['data'].shape)).mean(-2).mean(1).mean(0))

# # dat_all_recunrec = h5py.File('processed_dat/dat_all_recunrec.hdf5', 'x')
# # for key1 in dat_all_dict:
# #     if isinstance(dat_all_dict[key1], dict):
# #         for key2  in dat_all_dict[key1]:
# #             if isinstance(dat_all_dict[key1][key2], dict):
# #                 for key3  in dat_all_dict[key1][key2]:
# #                     dat_all_recunrec.create_dataset(
# #                         str(key1)+'/'+str(key2)+'/'+str(key3), data=dat_all_dict[key1][key2][key3],
# #                         compression='gzip', compression_opts=9)
# #             else:
# #                 dat_all_recunrec.create_dataset(
# #                     str(key1)+'/'+str(key2), data=dat_all_dict[key1][key2],
# #                     compression='gzip', compression_opts=9)
# #     else:
# #         dat_all_recunrec.create_dataset(
# #             str(key1), data=dat_all_dict[key1],
# #             compression='gzip', compression_opts=9)
# # dat_all2h5 = h5py.File('processed_dat/dat_all_recunrec.hdf5', 'r')
# # tvals = {}
# # for key in dat_all:
# #     if isinstance(dat_all[key], h5py.Group):
# #         tvals[key] = {}
# #         for key2 in dat_all[key]:
# #             if isinstance(dat_all[key][key2], h5py.Group):
# #                 tvals[key][key2] = {}
# #                 for key3 in dat_all[key][key2]:
# #                     tvals[key][key2][key3] = (np.mean(dat_all[key][key2][key3], 0) /
# #                                               (np.std(dat_all[key][key2][key3], 0) /
# #                                                np.sqrt(len(dat_all[key][key2][key3]))))
# #             else:
# #                 tvals[key][key2] = (np.mean(dat_all[key][key2], 0) /
# #                                     (np.std(dat_all[key][key2], 0) /
# #                                      np.sqrt(len(dat_all[key][key2]))))
# #     # elif key=='subject'
# #     else:
# #         try:
# #             tvals[key] = (np.mean(dat_all[key], 0) /
# #                           (np.std(dat_all[key], 0) /
# #                            np.sqrt(len(dat_all[key]))))
# #         except TypeError:
# #             tvals[key] = dat_all[key]
# # tvals['recalled-unrecalled'] = np.mean(
# #     dat_all['recalled'][:]-dat_all['unrecalled'][:], 0) / (np.std(
# #         dat_all['recalled'][:]-dat_all['unrecalled'][:], 0) / np.sqrt(
# #             len(dat_all['recalled'])))










dat_all_dict = {'subject': [], 'all': [], 'recalled': [], 'unrecalled': [],
                'serialpos_all': [], 'serialpos_recalled': [],
                'serialpos_unrecalled': [],
                'item_res_all':  {i: [] for i in range(4)},
                'item_res_nolist':  {i: [] for i in range(4)},
                'item_res_norecallability':  {i: [] for i in range(4)},
                'item_res_noserialpos':  {i: [] for i in range(4)},
                'item_res_nosession':  {i: [] for i in range(4)},
                'recalled_logit': {i: [] for i in range(4)},
                'residuals_sesslist':  {i: [] for i in range(4)},
                'residuals_list':  {i: [] for i in range(4)},
                'residuals_sess':  {i: [] for i in range(4)},
                'recalled_logit_shuffled': {i: [] for i in range(4)},
                'residuals_sesslist_shuffled':  {i: [] for i in range(4)},
                'residuals_list_shuffled':  {i: [] for i in range(4)},
                'residuals_sess_shuffled':  {i: [] for i in range(4)},
                'recalled_logit_shuffled1': {i: [] for i in range(4)},
                'residuals_sesslist_shuffled1':  {i: [] for i in range(4)},
                'residuals_list_shuffled1':  {i: [] for i in range(4)},
                'residuals_sess_shuffled1':  {i: [] for i in range(4)}
}


# # processed_file = processed_files[0]

# for processed_file in processed_files:
#     pf = h5py.File(processed_file, 'r')
#     subj = processed_file.split('/')[-1].split('_')[0]
#     print(subj)
#     dat_all_dict['subject'].append(subj.encode())
#     dat_all_dict['all'].append(np.mean(pf['data'], -2).mean(1).mean(0))
#     dat_all_dict['unrecalled'].append(
#         ma.array(pf['data'], mask=np.broadcast_to(np.bool8(pf['recalled'][()])[
#             :, :, np.newaxis, :, np.newaxis], pf['data'].shape)).mean(
#                 -2).mean(1).mean(0))
#     dat_all_dict['recalled'].append(
#         ma.array(pf['data'], mask=~np.broadcast_to(np.bool8(pf['recalled'][()])[
#             :, :, np.newaxis, :, np.newaxis], pf['data'].shape)).mean(
#                 -2).mean(1).mean(0))
#     # the below are almost redundant with all/recalled/unrecalled, but
#     # not every subject has the same number of sessions, so there
#     # should be slight differences:
#     dat_all_dict['serialpos_all'].append(np.mean(pf['data'], 1).mean(0))
#     dat_all_dict['serialpos_unrecalled'].append(
#         ma.array(pf['data'], mask=np.broadcast_to(np.bool8(pf['recalled'][()])[
#             :, :, np.newaxis, :, np.newaxis], pf['data'].shape)).mean(
#                 1).mean(0))
#     dat_all_dict['serialpos_recalled'].append(
#         ma.array(pf['data'], mask=~np.broadcast_to(np.bool8(pf['recalled'][()])[
#             :, :, np.newaxis, :, np.newaxis], pf['data'].shape)).mean(
#                 1).mean(0))
#     quartiles_thresh = {
#         'recalled_logit': np.nanpercentile(
#             np.ravel(pf['recalled_logit']), [0, 25, 50, 75, 100]),
#         'item_res_all': np.nanpercentile(
#             np.ravel(pf['item_res_all']), [0, 25, 50, 75, 100]),
#         'item_res_nolist': np.nanpercentile(
#             np.ravel(pf['item_res_nolist']), [0, 25, 50, 75, 100]),
#         'item_res_norecallability': np.nanpercentile(
#             np.ravel(pf['item_res_norecallability']), [0, 25, 50, 75, 100]),
#         'item_res_noserialpos': np.nanpercentile(
#             np.ravel(pf['item_res_noserialpos']), [0, 25, 50, 75, 100]),
#         'item_res_nosession': np.nanpercentile(
#             np.ravel(pf['item_res_nosession']), [0, 25, 50, 75, 100]),
#         'residuals_sesslist': np.nanpercentile(
#             np.ravel(pf['residuals_sesslist']), [0, 25, 50, 75, 100]),
#         'residuals_list': np.nanpercentile(
#             np.ravel(pf['residuals_list']), [0, 25, 50, 75, 100]),
#         'residuals_sess': np.nanpercentile(
#             np.ravel(pf['residuals_sess']), [0, 25, 50, 75, 100])
#     }
#     for dv in quartiles_thresh:
#         for i, thresh in enumerate(quartiles_thresh[dv][:-1]):
#                 dat_all_dict[dv][i].append(
#                     ma.array(pf['data'], mask=np.broadcast_to(
#                         ((pf[dv][:]<thresh) | (pf[dv][:]>=quartiles_thresh[dv][
#                             i+1]))[:, :, np.newaxis, np.newaxis, np.newaxis],
#                         pf['data'].shape)).mean(-2).mean(1).mean(0))

#     # unrec = ma.array(pf['data'], mask=np.broadcast_to(np.bool8(pf['recalled'][()])[
#     #     :, :, np.newaxis, :, np.newaxis], pf['data'].shape))
    
#     # dimensions: sessions x lists x frequencies x items x time:
#     data_shuffled = np.ones((len(pf['data']), SHUFFLES*24, 15, 24, 120))*np.nan
#     data_shuffled1 = np.ones((len(pf['data']), 24, 15, 24, 120))*np.nan
#     for sess in range(len(pf['data'])):
#         sessdat = np.reshape(np.transpose(pf['data'][sess], (0, 2, 1, 3)),
#                              (24*24, 15, 120))
#         sess_recalled = np.ravel(pf['recalled'][sess])
#         sessdat_recalled = sessdat[sess_recalled==1]
#         sessdat_unrecalled = sessdat[sess_recalled==0]
#         sessdat_shuffled = np.ones((SHUFFLES, 24, 24, 15, 120))*np.nan
#         for i in range(SHUFFLES):
#             np.random.shuffle(sessdat_recalled)
#             np.random.shuffle(sessdat_unrecalled)
#             shuffled_dat = np.ones((24*24, 15, 120))*np.nan
#             shuffled_dat[sess_recalled==1] = sessdat_recalled
#             shuffled_dat[sess_recalled==0] = sessdat_unrecalled
#             sessdat_shuffled[i] = np.reshape(shuffled_dat, (24, 24, 15, 120))
#         data_shuffled[sess] = np.transpose(
#             np.reshape(sessdat_shuffled, (SHUFFLES*24, 24, 15, 120)),
#             (0, 2, 1, 3))
#         data_shuffled1[sess] = np.transpose(
#             np.reshape(shuffled_dat, (24, 24, 15, 120)),
#             (0, 2, 1, 3))
#     listvars = ['recalled_logit', 'residuals_sesslist',
#                 'residuals_list', 'residuals_sess']
#     for dv in listvars:
#         for i, thresh in enumerate(quartiles_thresh[dv][:-1]):
#                 dat_all_dict[dv+'_shuffled'][i].append(
#                     ma.array(data_shuffled, mask=np.broadcast_to(
#                         np.repeat(((pf[dv][:]<thresh) |
#                                    (pf[dv][:]>=quartiles_thresh[dv][
#                                        i+1])),
#                                   SHUFFLES, 1)[:, :, np.newaxis,
#                                                np.newaxis, np.newaxis],
#                         data_shuffled.shape)).mean(-2).mean(1).mean(0))
#                 dat_all_dict[dv+'_shuffled1'][i].append(
#                     ma.array(data_shuffled1, mask=np.broadcast_to(
#                         ((pf[dv][:]<thresh) |
#                                    (pf[dv][:]>=quartiles_thresh[dv][
#                                        i+1]))[:, :, np.newaxis,
#                                                np.newaxis, np.newaxis],
#                         data_shuffled1.shape)).mean(-2).mean(1).mean(0))
        

# # listvars = ['recalled_logit', 'residuals_sesslist',
# #             'residuals_list', 'residuals_sess']
# # for dv in listvars:
# #     for quantile in dat_all_dict[dv]:
# #         dat_all_dict[dv+'_shuffled'][quantile] = dat_all_dict[dv][quantile][97:]
# #         dat_all_dict[dv][quantile] = dat_all_dict[dv][quantile][:97]




# dat_all = h5py.File('./processed_dat/dat_all.hdf5', 'x')
# for key1 in dat_all_dict:
#     if isinstance(dat_all_dict[key1], dict):
#         for key2  in dat_all_dict[key1]:
#             if isinstance(dat_all_dict[key1][key2], dict):
#                 for key3  in dat_all_dict[key1][key2]:
#                     dat_all.create_dataset(
#                         str(key1)+'/'+str(key2)+'/'+str(key3), data=dat_all_dict[key1][key2][key3],
#                         compression='gzip', compression_opts=9)
#             else:
#                 dat_all.create_dataset(
#                     str(key1)+'/'+str(key2), data=dat_all_dict[key1][key2],
#                     compression='gzip', compression_opts=9)
#     else:
#         dat_all.create_dataset(
#             str(key1), data=dat_all_dict[key1],
#             compression='gzip', compression_opts=9)
# dat_all.close()



# # dat_all_dict = {'subject': [], 'recalled': [], 'unrecalled': [],
# #                 'recalled_logit': {'recalled': {i: [] for i in range(4)},
# #                                    'unrecalled': {i: [] for i in range(4)},
# #                                    'all': {i: [] for i in range(4)}},
# #                 'residuals_interlist': {
# #                     'recalled': {i: [] for i in range(4)},
# #                     'unrecalled': {i: [] for i in range(4)},
# #                     'all': {i: [] for i in range(4)}},
# #                 'residuals_intersess': {
# #                     'recalled': {i: [] for i in range(4)},
# #                     'unrecalled': {i: [] for i in range(4)},
# #                     'all': {i: [] for i in range(4)}}}
# # }

# # for processed_file in processed_files:
# #     pf = h5py.File(processed_file, 'r')
# #     subj = processed_file.split('/')[-1].split('_')[0]
# #     print(subj)
# #     dat_all_dict['subject'].append(subj.encode())
# #     rec_mask = ~np.broadcast_to(np.bool8(pf['recalled'][:])[
# #         :, :, np.newaxis, :, np.newaxis], pf['data'].shape)
# #     unrec_mask = np.broadcast_to(np.bool8(pf['recalled'][:])[
# #         :, :, np.newaxis, :, np.newaxis], pf['data'].shape)
# #     dat_all_dict['unrecalled'].append(
# #         ma.array(pf['data'], mask=unrec_mask).mean(-2).mean(1).mean(0))
# #     dat_all_dict['recalled'].append(
# #         ma.array(pf['data'], mask=rec_mask).mean(-2).mean(1).mean(0))
# #     quartiles_thresh = {
# #         'recalled_logit': np.nanpercentile(
# #             np.ravel(pf['recalled_logit']), [0, 25, 50, 75, 100]),
# #         'residuals_interlist': np.nanpercentile(
# #             np.ravel(pf['residuals_interlist']), [0, 25, 50, 75, 100]),
# #         'residuals_intersess': np.nanpercentile(
# #             np.ravel(pf['residuals_intersess']), [0, 25, 50, 75, 100])
# #     }
# #     for dv in quartiles_thresh:
# #         for i, thresh in enumerate(quartiles_thresh[dv][:-1]):
# #                 dat_all_dict[dv]['all'][i].append(
# #                     ma.array(pf['data'], mask=np.broadcast_to(
# #                         ((pf[dv][:]<thresh) | (pf[dv][:]>=quartiles_thresh[dv][
# #                             i+1]))[:, :, np.newaxis, np.newaxis, np.newaxis],
# #                         pf['data'].shape)).mean(-2).mean(1).mean(0))
# #                 dat_all_dict[dv]['recalled'][i].append(
# #                     ma.array(pf['data'], mask=rec_mask & np.broadcast_to(
# #                         ((pf[dv][:]<thresh) | (pf[dv][:]>=quartiles_thresh[dv][
# #                             i+1]))[:, :, np.newaxis, np.newaxis, np.newaxis],
# #                         pf['data'].shape)).mean(-2).mean(1).mean(0))
# #                 dat_all_dict[dv]['unrecalled'][i].append(
# #                     ma.array(pf['data'], mask=unrec_mask & np.broadcast_to(
# #                         ((pf[dv][:]<thresh) | (pf[dv][:]>=quartiles_thresh[dv][
# #                             i+1]))[:, :, np.newaxis, np.newaxis, np.newaxis],
# #                         pf['data'].shape)).mean(-2).mean(1).mean(0))

# # dat_all_recunrec = h5py.File('processed_dat/dat_all_recunrec.hdf5', 'x')
# # for key1 in dat_all_dict:
# #     if isinstance(dat_all_dict[key1], dict):
# #         for key2  in dat_all_dict[key1]:
# #             if isinstance(dat_all_dict[key1][key2], dict):
# #                 for key3  in dat_all_dict[key1][key2]:
# #                     dat_all_recunrec.create_dataset(
# #                         str(key1)+'/'+str(key2)+'/'+str(key3), data=dat_all_dict[key1][key2][key3],
# #                         compression='gzip', compression_opts=9)
# #             else:
# #                 dat_all_recunrec.create_dataset(
# #                     str(key1)+'/'+str(key2), data=dat_all_dict[key1][key2],
# #                     compression='gzip', compression_opts=9)
# #     else:
# #         dat_all_recunrec.create_dataset(
# #             str(key1), data=dat_all_dict[key1],
# #             compression='gzip', compression_opts=9)
# # dat_all2h5 = h5py.File('processed_dat/dat_all_recunrec.hdf5', 'r')
# # tvals = {}
# # for key in dat_all:
# #     if isinstance(dat_all[key], h5py.Group):
# #         tvals[key] = {}
# #         for key2 in dat_all[key]:
# #             if isinstance(dat_all[key][key2], h5py.Group):
# #                 tvals[key][key2] = {}
# #                 for key3 in dat_all[key][key2]:
# #                     tvals[key][key2][key3] = (np.mean(dat_all[key][key2][key3], 0) /
# #                                               (np.std(dat_all[key][key2][key3], 0) /
# #                                                np.sqrt(len(dat_all[key][key2][key3]))))
# #             else:
# #                 tvals[key][key2] = (np.mean(dat_all[key][key2], 0) /
# #                                     (np.std(dat_all[key][key2], 0) /
# #                                      np.sqrt(len(dat_all[key][key2]))))
# #     # elif key=='subject'
# #     else:
# #         try:
# #             tvals[key] = (np.mean(dat_all[key], 0) /
# #                           (np.std(dat_all[key], 0) /
# #                            np.sqrt(len(dat_all[key]))))
# #         except TypeError:
# #             tvals[key] = dat_all[key]
# # tvals['recalled-unrecalled'] = np.mean(
# #     dat_all['recalled'][:]-dat_all['unrecalled'][:], 0) / (np.std(
# #         dat_all['recalled'][:]-dat_all['unrecalled'][:], 0) / np.sqrt(
# #             len(dat_all['recalled'])))







dat_all = h5py.File('../processed_dat/dat_all.hdf5', 'r')

tvals = {}
for key in dat_all:
    if isinstance(dat_all[key], h5py.Group):
        tvals[key] = {}
        for key2 in dat_all[key]:
            tvals[key][key2] = (np.mean(dat_all[key][key2], 0) /
                                (np.std(dat_all[key][key2], 0) /
                                 np.sqrt(len(dat_all[key][key2]))))
    # elif key=='subject'
    else:
        try:
            tvals[key] = (np.mean(dat_all[key], 0) /
                          (np.std(dat_all[key], 0) /
                           np.sqrt(len(dat_all[key]))))
        except TypeError:
            tvals[key] = dat_all[key]
tvals['recalled-unrecalled'] = {
    'all': np.mean(
        dat_all['recalled'][:]-dat_all['unrecalled'][:], 0) / (np.std(
            dat_all['recalled'][:]-dat_all['unrecalled'][:], 0) / np.sqrt(
                len(dat_all['recalled']))),
    'serialpos': np.mean(dat_all['serialpos_recalled'][:]-
                         dat_all['serialpos_unrecalled'][:], 0) /
    (np.std(dat_all['serialpos_recalled'][:]-
            dat_all['serialpos_unrecalled'][:], 0) / np.sqrt(
                len(dat_all['recalled'])))
}





procpow = h5py.File(processed_files[-11], 'r')
# quantiles_thresh = {
#     'recalled_logit': np.nanpercentile(
#         np.ravel(procpow['recalled_logit']), [0, 25, 50, 75, 100]),
#     'residuals_interlist': np.nanpercentile(
#         np.ravel(procpow['residuals_interlist']), [0, 25, 50, 75, 100]),
#     'residuals_intersess': np.nanpercentile(
#         np.ravel(procpow['residuals_intersess']), [0, 25, 50, 75, 100])
# }






wrd_fmt = [{'style': 'normal', 'weight': 'normal', 'size': 'x-small'},
           {'style': 'italic', 'weight': 'bold', 'size': 'x-small'}]

# maxval = 3
maxval = 4
minval = -maxval
cbtitle = r'$z($power$)$'
col1 = (0.4, 0.4, 0.4)
col2 = (0.6, 0.6, 0.6)
# bin_n = 38
bin_n = 'auto'
cbtitle = r'$z($power$)$'

indices = [3]
# indices = [2, 4]
# indices = [17, 18]
# fig = plt.figure(figsize=(9, 7))



fig = plt.figure(figsize=(5.5, 4))
gs0 = gridspec.GridSpec(3, 2, height_ratios=[2, 3, 3], wspace=0.6)
# gs00 = gridspec.GridSpecFromSubplotSpec(2, 9, subplot_spec=gs0[0, :],
#                                         height_ratios=[6, 1],
#                                         wspace=0.2, hspace=1.5)
gs00 = gridspec.GridSpecFromSubplotSpec(1, 9, subplot_spec=gs0[0, :],
                                        wspace=0.2, hspace=1.5)
# In [8]: procpow['recalled'][15, indices]
# Out[8]: 
# array([[1, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1,
#         1, 1],
#        [1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 1,
#         0, 1]])
# In [10]: procpow['recalled'][15, indices].mean(1)
# Out[10]: array([0.875     , 0.45833333])
# In [11]: procpow['recalled'][15, indices].sum(1)
# Out[11]: array([21, 11])


plotrow = 0
axs1 = np.empty((1, 9), object)
for dat, words, recalled, prediction in zip(
        procpow['data'][15, indices], procpow['words'][15, indices],
        procpow['recalled'][15, indices], procpow['prediction'][15, indices]):
    for plotcol, serialpos in enumerate(
            list(range(8)) + [None]):
        if serialpos is None:
            continue
        #plotcol = serialpos
        axs1[plotrow, plotcol] = plt.Subplot(fig, gs00[plotrow, plotcol])
        freqplot = axs1[plotrow, plotcol].imshow(
            dat[:, serialpos], aspect='auto',
            origin='lower', cmap='bwr', vmin=minval, vmax=maxval)
        axs1[plotrow, plotcol].set_title(words[serialpos].decode(),
                                          fontdict=wrd_fmt[recalled[serialpos]])
        axs1[plotrow, plotcol].set_xticks([55, 119])
        axs1[plotrow, plotcol].plot([40, 40], [0, 14], 'k-')
        # axs1[plotrow+1][plotcol] = plt.Subplot(fig, gs00[plotrow+1, plotcol])
        # axs1[plotrow+1][plotcol].barh(0.2, prediction[serialpos]-0.5)
        # axs1[plotrow+1][plotcol].plot([0, 0], [-0.25, 0.66], 'k', clip_on=False)
        # axs1[plotrow+1][plotcol].set_xlim((-0.15, 0.15))
        # axs1[plotrow+1][plotcol].set_ylim((-0.24, 0.64))
        # axs1[plotrow+1][plotcol].set_xticks((-0.1, 0, 0.1))
        # axs1[plotrow+1][plotcol].set_yticks([])
        axs1[plotrow, plotcol].set_xticklabels([0.3, 1.6])
        axs1[plotrow, plotcol].set_yticks([0, 4, 9, 14])
        # axs1[plotrow+1][plotcol].set_xticklabels((0.4,'', 0.6))
        if plotcol == 0:
            axs1[plotrow, plotcol].set_ylabel('Frequency (Hz)', labelpad=0)
            axs1[plotrow, plotcol].set_xlabel('Time (s)', labelpad=0)
            # axs[plotrow, plotcol].set_yticklabels(np.round(procpow['data'].attrs['frequency'][[0, 4, 9, 14]]))
            axs1[plotrow, plotcol].set_yticklabels([2, 7, 39, 200])
            # axs1[plotrow+1][plotcol].set_xlabel(r'$\hat{p}($recall$)$', labelpad=0)
        else:
            plt.setp(axs1[plotrow, plotcol].get_yticklabels(), visible=False)
            # plt.setp(axs1[plotrow+1, plotcol].get_xticklabels(), visible=False)
        #axs[2, plotcol].set_visible(False)
    # plotrow += 3
# axs1[0, 6].axis('off')
# axs1[1, 6].axis('off')
# axs1[2, 6].set_visible(False)
# axs1[3, 6].axis('off')
# axs1[4, 6].axis('off')

for i in [0]: #[0, 1]:
    axs1[i, 8] = plt.Subplot(fig, gs00[i, 8])
    axs1[i, 8].text(0.5, 0.5, '...',  fontdict={'weight': 'bold', 'size': 'xx-large'},
                    horizontalalignment='center', verticalalignment='center',
                    transform=axs1[i, 8].transAxes)
    axs1[i, 8].axis('off')
# ax_cb1 = fig.add_axes([0.92, 0.753, 0.06, 0.02])
# ax_cb1 = fig.add_axes([0.92, 0.73, 0.06, 0.02])
#ax_cb1 = fig.add_axes([0.90, 0.72, 0.08, 0.02])
ax_cb1 = fig.add_axes([0.90, 0.71, 0.08, 0.02])
norm = mpl.colors.Normalize(vmin=-maxval, vmax=maxval)
cb = mpl.colorbar.ColorbarBase(ax_cb1, cmap=plt.cm.bwr, # label='t(131)',
                               # norm=norm, ticks=range(-4, 5, 2),
                               # norm=norm, ticks=range(-2, 3, 2),
                               norm=norm, ticks=range(-3, 4, 3),
                               ticklocation='bottom',
                               orientation='horizontal')
#ax_cb.set_title(cbtitle, size='large')
ax_cb1.set_ylabel(cbtitle, rotation=0, labelpad=25, verticalalignment='center')
ax_cb1.tick_params(axis='both', which='major', pad=2)
# plt.savefig('./figs/power_samplelists.pdf')

for ax in np.ravel(axs1):
    if not ax is None:
        print(ax)
        fig.add_subplot(ax)

vmax = 12
# fig, axs = plt.subplots(2, 1, sharex=True, sharey=True, figsize=(1, 2))
axs2 = np.empty((1, 4), object)
gs01 = gridspec.GridSpecFromSubplotSpec(1, 4, subplot_spec=gs0[1, :],
                                        # width_ratios=[7, 7, 7, 7, 5, 4, 4, 4],
                                        wspace=0.6, hspace=0.2)
axs2[0, 1] = plt.Subplot(fig, gs01[0, 1])
axs2[0, 1].imshow(tvals['unrecalled'], aspect='auto',
                  origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
axs2[0, 3] = plt.Subplot(fig, gs01[0, 3])
axs2[0, 3].imshow(tvals['recalled'], aspect='auto',
                  origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
axs2[0, 1].set_yticks([0, 4, 9, 14])
axs2[0, 3].set_yticks([0, 4, 9, 14])
# axs[plotrow, plotcol].set_yticklabels(np.round(procpow['data'].attrs['frequency'][[0, 4, 9, 14]]))
axs2[0, 1].set_yticklabels([2, 7, 39, 200])
axs2[0, 3].set_yticklabels([2, 7, 39, 200])
axs2[0, 1].set_ylabel('Frequency (Hz)', labelpad=0)
axs2[0, 3].set_ylabel('Frequency (Hz)', labelpad=0)
axs2[0, 1].set_xticks([55, 119])
axs2[0, 1].plot([40, 40], [0, 14], 'k-')
axs2[0, 3].set_xticks([55, 119])
axs2[0, 3].plot([40, 40], [0, 14], 'k-')
#plt.setp(axs2[0, 1].get_xticklabels(), visible=False)
axs2[0, 1].set_xticklabels([0.3, 1.6])
axs2[0, 3].set_xticklabels([0.3, 1.6])
axs2[0, 1].set_xlabel('Time (s)', labelpad=0)
axs2[0, 3].set_xlabel('Time (s)', labelpad=0)
# ax_cb2 = fig.add_axes([0.05, 0.03, 0.06, 0.02])
# ax_cb2 = fig.add_axes([0.35, 0.405, 0.06, 0.02])
# # ax_cb2 = fig.add_axes([0.24, 0.03, 0.06, 0.02])
# norm = mpl.colors.Normalize(vmin=-vmax, vmax=vmax)
# cb = mpl.colorbar.ColorbarBase(ax_cb2, cmap=plt.cm.bwr, # label='t(131)',
#                                # norm=norm, ticks=range(-4, 5, 2),
#                                # norm=norm, ticks=range(-5, 6, 5),
#                                norm=norm, ticks=range(-9, 10, 9),
#                                ticklocation='bottom',
#                                orientation='horizontal')
# #ax_cb.set_title(cbtitle, size='large')
# ax_cb2.set_ylabel(r'$t(96)$', rotation=0, labelpad=15, verticalalignment='center')
# ax_cb2.tick_params(axis='both', which='major', pad=2)

# axs2[0, 1].annotate('', xy=(87, -7), xytext=(87, -16), ha='center',
#                     va='center', size=21, arrowprops=dict(
#                         arrowstyle='-[', shrinkA=0.5, shrinkB=5,
#                         fc="k", ec="k",
#                         connectionstyle="arc3,rad=0.0"),
#                     annotation_clip=False)

axs2[0, 1].annotate('', xy=(87, -8), xytext=(87, -13), ha='center',
                    va='center', size=16, arrowprops=dict(
                        arrowstyle='-[', shrinkA=0.5, shrinkB=5,
                        fc="k", ec="k",
                        connectionstyle="arc3,rad=0.0"),
                    annotation_clip=False)

axs2[0, 3].annotate('', xy=(87, -8), xytext=(87, -13), ha='center',
                    va='center', size=16, arrowprops=dict(
                        arrowstyle='-[', shrinkA=0.5, shrinkB=5,
                        fc="k", ec="k",
                        connectionstyle="arc3,rad=0.0"),
                    annotation_clip=False)

for ax in np.ravel(axs2):
    if not ax is None:
        print(ax)
        fig.add_subplot(ax)


vmax = 12
# fig, axs = plt.subplots(2, 1, sharex=True, sharey=True, figsize=(1, 2))
axs3 = np.empty((1, 4), object)
gs02 = gridspec.GridSpecFromSubplotSpec(1, 4, subplot_spec=gs0[2, :],
                                        width_ratios=[8, 3, 8, 3],
                                        wspace=0.6, hspace=0.2)
axs3[0, 1] = plt.Subplot(fig, gs02[0, 1])
axs3[0, 1].imshow(np.reshape(tvals['unrecalled'][:, 55:].mean(1), (15, 1)), aspect=0.5,
                  origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
axs3[0, 3] = plt.Subplot(fig, gs02[0, 3])
axs3[0, 3].imshow(np.reshape(tvals['recalled'][:, 55:].mean(1), (15, 1)), aspect=0.5,
                  origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
axs3[0, 1].set_yticks([0, 4, 9, 14])
axs3[0, 3].set_yticks([0, 4, 9, 14])
# axs[plotrow, plotcol].set_yticklabels(np.round(procpow['data'].attrs['frequency'][[0, 4, 9, 14]]))
axs3[0, 1].set_yticklabels([2, 7, 39, 200])
axs3[0, 3].set_yticklabels([2, 7, 39, 200])
axs3[0, 1].set_ylabel('Frequency (Hz)', labelpad=0)
axs3[0, 3].set_ylabel('Frequency (Hz)', labelpad=0)
axs3[0, 1].set_xticks([])
# axs2[0, 1].plot([40, 40], [0, 14], 'k-')
axs3[0, 3].set_xticks([])
# axs2[0, 3].plot([40, 40], [0, 14], 'k-')
#plt.setp(axs2[0, 1].get_xticklabels(), visible=False)
# axs2[0, 1].set_xticklabels([0.3, 1.6])
# axs2[0, 3].set_xticklabels([0.3, 1.6])
# axs2[0, 1].set_xlabel('Time (s)', labelpad=0)
# axs2[0, 3].set_xlabel('Time (s)', labelpad=0)
# ax_cb2 = fig.add_axes([0.05, 0.03, 0.06, 0.02])
# ax_cb2 = fig.add_axes([0.35, 0.405, 0.06, 0.02])
# # ax_cb2 = fig.add_axes([0.24, 0.03, 0.06, 0.02])
# norm = mpl.colors.Normalize(vmin=-vmax, vmax=vmax)
# cb = mpl.colorbar.ColorbarBase(ax_cb2, cmap=plt.cm.bwr, # label='t(131)',
#                                # norm=norm, ticks=range(-4, 5, 2),
#                                # norm=norm, ticks=range(-5, 6, 5),
#                                norm=norm, ticks=range(-9, 10, 9),
#                                ticklocation='bottom',
#                                orientation='horizontal')
# #ax_cb.set_title(cbtitle, size='large')
# ax_cb2.set_ylabel(r'$t(96)$', rotation=0, labelpad=15, verticalalignment='center')
# ax_cb2.tick_params(axis='both', which='major', pad=2)


for ax in np.ravel(axs3):
    if not ax is None:
        print(ax)
        fig.add_subplot(ax)

ax_cb2 = fig.add_axes([0.1, 0.07, 0.08, 0.02]) # [0.92, 0.753, 0.06, 0.02][0.13, 0.4, 0.06, 0.02]
norm = mpl.colors.Normalize(vmin=-vmax, vmax=vmax)
cb = mpl.colorbar.ColorbarBase(ax_cb2, cmap=plt.cm.bwr, # label='t(131)',
                               # norm=norm, ticks=range(-4, 5, 2),
                               # norm=norm, ticks=range(-5, 6, 5),
                               norm=norm, ticks=range(-9, 10, 9),
                               ticklocation='bottom',
                               orientation='horizontal')
# #ax_cb.set_title(cbtitle, size='large')
ax_cb2.set_ylabel(r'$t(96)$', rotation=0, labelpad=15, verticalalignment='center')
ax_cb2.tick_params(axis='both', which='major', pad=2)



labelaxs = {'unrecalled': [], 'recalled': []}
startcoords = {'unrecalled': (0.05, 0.25), 'recalled': (0.55, 0.25)}
# for i in range(9):
vmax=60
for label in labelaxs:
    for i in range(10):
        tfplots = (dat_all[label][i] /
                   (np.std(dat_all[label],0) /
                    np.sqrt(len(dat_all[label]))))
        # rec_axs.append(fig.add_axes([0.05+(0.005*i), 0.27-(0.005*i), 0.1, 0.1]))
        labelaxs[label].append(
            fig.add_axes([startcoords[label][0]+(0.005*i),
                          startcoords[label][1]-(0.005*i), 0.1, 0.12]))
        # tfplots = ((dat_all['recalled'][i]-np.mean(dat_all['recalled'], 0)) /
        #            (np.std(dat_all['recalled'],0) /
        #             np.sqrt(len(dat_all['recalled']))))
        # dat_all['recalled'][i]
        labelaxs[label][-1].imshow(
            tfplots, aspect='auto',
            origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
        labelaxs[label][-1].set_xticks([55, 119])
        labelaxs[label][-1].set_xticks([55, 119])
        labelaxs[label][-1].plot([40, 40], [0, 14], 'k-')
        labelaxs[label][-1].set_xticklabels([])
        labelaxs[label][-1].set_yticks([0, 4, 9, 13])
        labelaxs[label][-1].set_yticklabels([]) 
        if i==0:
            # labelaxs[label][-1].set_yticklabels([2, 7, 39, 200])
            labelaxs[label][-1].set_title(label, fontweight='bold')
        # else:
        #     labelaxs[label][-1].set_yticklabels([])        
    # labelaxs[label][-1].set_xticklabels([0.3, 1.6])
    arrow = labelaxs[label][-1].arrow(
        1.12, 0.5, 0.6, 0.6, transform=labelaxs[label][-1].transAxes, clip_on=False,
        width=0.02, head_width=0.12, color='k')
    arrow = labelaxs[label][-1].arrow(
        1.12, 0.5, 0.6, -0.6, transform=labelaxs[label][-1].transAxes, clip_on=False,
        width=0.02, head_width=0.12, color='k')






fig.subplots_adjust(left=0.1, bottom=0.05, right=0.98, top=0.93, wspace=0.,
                    hspace=1)
plt.savefig('./figs/power_samplelists_recunrec_nolabels_new.pdf')
# # fig.text(0.0, 0.45, r'A',  fontdict={'weight': 'bold', 'size': 'large'},
# fig.text(0.01, 0.62, r'A',  fontdict={'weight': 'bold', 'size': 'large'},
#                     horizontalalignment='left', verticalalignment='bottom')

# # fig.text(0.0, 0.38, r'B',  fontdict={'weight': 'bold', 'size': 'large'},
# fig.text(0.01, 0.57, r'B',  fontdict={'weight': 'bold', 'size': 'large'},
#          horizontalalignment='left', verticalalignment='bottom')
# # plt.savefig('./figs/power_samplelists_recunrec_labels.pdf')

































































wrd_fmt = [{'style': 'normal', 'weight': 'normal', 'size': 'x-small'},
           {'style': 'italic', 'weight': 'bold', 'size': 'x-small'}]

# maxval = 3
maxval = 4
minval = -maxval
cbtitle = r'$z($power$)$'
col1 = (0.4, 0.4, 0.4)
col2 = (0.6, 0.6, 0.6)
# bin_n = 38
bin_n = 'auto'
cbtitle = r'$z($power$)$'

indices = [3]
# indices = [2, 4]
# indices = [17, 18]
# fig = plt.figure(figsize=(9, 7))



fig = plt.figure(figsize=(7, 6))
gs0 = gridspec.GridSpec(3, 2, height_ratios=[3, 2, 2], wspace=0.6)
gs00 = gridspec.GridSpecFromSubplotSpec(2, 9, subplot_spec=gs0[0, :],
                                        height_ratios=[6, 1],
                                        wspace=0.2, hspace=1.5)
# In [8]: procpow['recalled'][15, indices]
# Out[8]: 
# array([[1, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1,
#         1, 1],
#        [1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 1,
#         0, 1]])
# In [10]: procpow['recalled'][15, indices].mean(1)
# Out[10]: array([0.875     , 0.45833333])
# In [11]: procpow['recalled'][15, indices].sum(1)
# Out[11]: array([21, 11])


plotrow = 0
axs1 = np.empty((2, 9), object)
for dat, words, recalled, prediction in zip(
        procpow['data'][15, indices], procpow['words'][15, indices],
        procpow['recalled'][15, indices], procpow['prediction'][15, indices]):
    for plotcol, serialpos in enumerate(
            list(range(4)) + [None] + list(range(20, 24))):
        if serialpos is None:
            continue
        #plotcol = serialpos
        axs1[plotrow, plotcol] = plt.Subplot(fig, gs00[plotrow, plotcol])
        freqplot = axs1[plotrow, plotcol].imshow(
            dat[:, serialpos], aspect='auto',
            origin='lower', cmap='bwr', vmin=minval, vmax=maxval)
        axs1[plotrow, plotcol].set_title(words[serialpos].decode(),
                                          fontdict=wrd_fmt[recalled[serialpos]])
        axs1[plotrow, plotcol].set_xticks([55, 119])
        axs1[plotrow, plotcol].plot([40, 40], [0, 14], 'k-')
        axs1[plotrow+1][plotcol] = plt.Subplot(fig, gs00[plotrow+1, plotcol])
        axs1[plotrow+1][plotcol].barh(0.2, prediction[serialpos]-0.5)
        axs1[plotrow+1][plotcol].plot([0, 0], [-0.25, 0.66], 'k', clip_on=False)
        axs1[plotrow+1][plotcol].set_xlim((-0.15, 0.15))
        axs1[plotrow+1][plotcol].set_ylim((-0.24, 0.64))
        axs1[plotrow+1][plotcol].set_xticks((-0.1, 0, 0.1))
        axs1[plotrow+1][plotcol].set_yticks([])
        axs1[plotrow, plotcol].set_xticklabels([0.3, 1.6])
        axs1[plotrow, plotcol].set_yticks([0, 4, 9, 14])
        axs1[plotrow+1][plotcol].set_xticklabels((0.4,'', 0.6))
        if plotcol == 0:
            axs1[plotrow, plotcol].set_ylabel('Frequency (Hz)', labelpad=0)
            axs1[plotrow, plotcol].set_xlabel('Time (s)', labelpad=0)
            # axs[plotrow, plotcol].set_yticklabels(np.round(procpow['data'].attrs['frequency'][[0, 4, 9, 14]]))
            axs1[plotrow, plotcol].set_yticklabels([2, 7, 39, 200])
            axs1[plotrow+1][plotcol].set_xlabel(r'$\hat{p}($recall$)$', labelpad=0)
        else:
            plt.setp(axs1[plotrow, plotcol].get_yticklabels(), visible=False)
            # plt.setp(axs1[plotrow+1, plotcol].get_xticklabels(), visible=False)
        #axs[2, plotcol].set_visible(False)
    # plotrow += 3
# axs1[0, 6].axis('off')
# axs1[1, 6].axis('off')
# axs1[2, 6].set_visible(False)
# axs1[3, 6].axis('off')
# axs1[4, 6].axis('off')

for i in [0, 1]:
    axs1[i, 4] = plt.Subplot(fig, gs00[i, 4])
    axs1[i, 4].text(0.5, 0.5, '...',  fontdict={'weight': 'bold', 'size': 'xx-large'},
                    horizontalalignment='center', verticalalignment='center',
                    transform=axs1[i, 4].transAxes)
    axs1[i, 4].axis('off')
# ax_cb1 = fig.add_axes([0.92, 0.753, 0.06, 0.02])
# ax_cb1 = fig.add_axes([0.92, 0.73, 0.06, 0.02])
ax_cb1 = fig.add_axes([0.88, 0.64, 0.1, 0.02])
norm = mpl.colors.Normalize(vmin=-maxval, vmax=maxval)
cb = mpl.colorbar.ColorbarBase(ax_cb1, cmap=plt.cm.bwr, # label='t(131)',
                               # norm=norm, ticks=range(-4, 5, 2),
                               # norm=norm, ticks=range(-2, 3, 2),
                               norm=norm, ticks=range(-3, 4, 3),
                               ticklocation='bottom',
                               orientation='horizontal')
#ax_cb.set_title(cbtitle, size='large')
ax_cb1.set_ylabel(cbtitle, rotation=0, labelpad=25, verticalalignment='center')
ax_cb1.tick_params(axis='both', which='major', pad=2)
# plt.savefig('./figs/power_samplelists.pdf')

for ax in np.ravel(axs1):
    if not ax is None:
        print(ax)
        fig.add_subplot(ax)

vmax = 12
# fig, axs = plt.subplots(2, 1, sharex=True, sharey=True, figsize=(1, 2))
axs2 = np.empty((1, 4), object)
gs01 = gridspec.GridSpecFromSubplotSpec(1, 4, subplot_spec=gs0[1, :],
                                        # width_ratios=[7, 7, 7, 7, 5, 4, 4, 4],
                                        wspace=0.6, hspace=0.2)
axs2[0, 1] = plt.Subplot(fig, gs01[0, 1])
axs2[0, 1].imshow(tvals['unrecalled'], aspect='auto',
                  origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
axs2[0, 3] = plt.Subplot(fig, gs01[0, 3])
axs2[0, 3].imshow(tvals['recalled'], aspect='auto',
                  origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
axs2[0, 1].set_yticks([0, 4, 9, 14])
axs2[0, 3].set_yticks([0, 4, 9, 14])
# axs[plotrow, plotcol].set_yticklabels(np.round(procpow['data'].attrs['frequency'][[0, 4, 9, 14]]))
axs2[0, 1].set_yticklabels([2, 7, 39, 200])
axs2[0, 3].set_yticklabels([2, 7, 39, 200])
axs2[0, 1].set_ylabel('Frequency (Hz)', labelpad=0)
axs2[0, 3].set_ylabel('Frequency (Hz)', labelpad=0)
axs2[0, 1].set_xticks([55, 119])
axs2[0, 1].plot([40, 40], [0, 14], 'k-')
axs2[0, 3].set_xticks([55, 119])
axs2[0, 3].plot([40, 40], [0, 14], 'k-')
#plt.setp(axs2[0, 1].get_xticklabels(), visible=False)
axs2[0, 1].set_xticklabels([0.3, 1.6])
axs2[0, 3].set_xticklabels([0.3, 1.6])
axs2[0, 1].set_xlabel('Time (s)', labelpad=0)
axs2[0, 3].set_xlabel('Time (s)', labelpad=0)
# ax_cb2 = fig.add_axes([0.05, 0.03, 0.06, 0.02])
# ax_cb2 = fig.add_axes([0.35, 0.405, 0.06, 0.02])
# # ax_cb2 = fig.add_axes([0.24, 0.03, 0.06, 0.02])
# norm = mpl.colors.Normalize(vmin=-vmax, vmax=vmax)
# cb = mpl.colorbar.ColorbarBase(ax_cb2, cmap=plt.cm.bwr, # label='t(131)',
#                                # norm=norm, ticks=range(-4, 5, 2),
#                                # norm=norm, ticks=range(-5, 6, 5),
#                                norm=norm, ticks=range(-9, 10, 9),
#                                ticklocation='bottom',
#                                orientation='horizontal')
# #ax_cb.set_title(cbtitle, size='large')
# ax_cb2.set_ylabel(r'$t(96)$', rotation=0, labelpad=15, verticalalignment='center')
# ax_cb2.tick_params(axis='both', which='major', pad=2)

axs2[0, 1].annotate('', xy=(87, -7), xytext=(87, -16), ha='center',
                    va='center', size=21, arrowprops=dict(
                        arrowstyle='-[', shrinkA=0.5, shrinkB=5,
                        fc="k", ec="k",
                        connectionstyle="arc3,rad=0.0"),
                    annotation_clip=False)

axs2[0, 3].annotate('', xy=(87, -7), xytext=(87, -16), ha='center',
                    va='center', size=21, arrowprops=dict(
                        arrowstyle='-[', shrinkA=5, shrinkB=5,
                        fc="k", ec="k",
                        connectionstyle="arc3,rad=0.0"),
                    annotation_clip=False)

for ax in np.ravel(axs2):
    if not ax is None:
        print(ax)
        fig.add_subplot(ax)


vmax = 12
# fig, axs = plt.subplots(2, 1, sharex=True, sharey=True, figsize=(1, 2))
axs3 = np.empty((1, 4), object)
gs02 = gridspec.GridSpecFromSubplotSpec(1, 4, subplot_spec=gs0[2, :],
                                        width_ratios=[8, 3, 8, 3],
                                        wspace=0.6, hspace=0.2)
axs3[0, 1] = plt.Subplot(fig, gs02[0, 1])
axs3[0, 1].imshow(np.reshape(tvals['unrecalled'][:, 55:].mean(1), (15, 1)), aspect=0.5,
                  origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
axs3[0, 3] = plt.Subplot(fig, gs02[0, 3])
axs3[0, 3].imshow(np.reshape(tvals['recalled'][:, 55:].mean(1), (15, 1)), aspect=0.5,
                  origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
axs3[0, 1].set_yticks([0, 4, 9, 14])
axs3[0, 3].set_yticks([0, 4, 9, 14])
# axs[plotrow, plotcol].set_yticklabels(np.round(procpow['data'].attrs['frequency'][[0, 4, 9, 14]]))
axs3[0, 1].set_yticklabels([2, 7, 39, 200])
axs3[0, 3].set_yticklabels([2, 7, 39, 200])
axs3[0, 1].set_ylabel('Frequency (Hz)', labelpad=0)
axs3[0, 3].set_ylabel('Frequency (Hz)', labelpad=0)
axs3[0, 1].set_xticks([])
# axs2[0, 1].plot([40, 40], [0, 14], 'k-')
axs3[0, 3].set_xticks([])
# axs2[0, 3].plot([40, 40], [0, 14], 'k-')
#plt.setp(axs2[0, 1].get_xticklabels(), visible=False)
# axs2[0, 1].set_xticklabels([0.3, 1.6])
# axs2[0, 3].set_xticklabels([0.3, 1.6])
# axs2[0, 1].set_xlabel('Time (s)', labelpad=0)
# axs2[0, 3].set_xlabel('Time (s)', labelpad=0)
# ax_cb2 = fig.add_axes([0.05, 0.03, 0.06, 0.02])
# ax_cb2 = fig.add_axes([0.35, 0.405, 0.06, 0.02])
# # ax_cb2 = fig.add_axes([0.24, 0.03, 0.06, 0.02])
# norm = mpl.colors.Normalize(vmin=-vmax, vmax=vmax)
# cb = mpl.colorbar.ColorbarBase(ax_cb2, cmap=plt.cm.bwr, # label='t(131)',
#                                # norm=norm, ticks=range(-4, 5, 2),
#                                # norm=norm, ticks=range(-5, 6, 5),
#                                norm=norm, ticks=range(-9, 10, 9),
#                                ticklocation='bottom',
#                                orientation='horizontal')
# #ax_cb.set_title(cbtitle, size='large')
# ax_cb2.set_ylabel(r'$t(96)$', rotation=0, labelpad=15, verticalalignment='center')
# ax_cb2.tick_params(axis='both', which='major', pad=2)


for ax in np.ravel(axs3):
    if not ax is None:
        print(ax)
        fig.add_subplot(ax)

ax_cb2 = fig.add_axes([0.1, 0.07, 0.1, 0.02]) # [0.92, 0.753, 0.06, 0.02][0.13, 0.4, 0.06, 0.02]
norm = mpl.colors.Normalize(vmin=-vmax, vmax=vmax)
cb = mpl.colorbar.ColorbarBase(ax_cb2, cmap=plt.cm.bwr, # label='t(131)',
                               # norm=norm, ticks=range(-4, 5, 2),
                               # norm=norm, ticks=range(-5, 6, 5),
                               norm=norm, ticks=range(-9, 10, 9),
                               ticklocation='bottom',
                               orientation='horizontal')
# #ax_cb.set_title(cbtitle, size='large')
ax_cb2.set_ylabel(r'$t(96)$', rotation=0, labelpad=15, verticalalignment='center')
ax_cb2.tick_params(axis='both', which='major', pad=2)



labelaxs = {'unrecalled': [], 'recalled': []}
startcoords = {'unrecalled': (0.05, 0.25), 'recalled': (0.55, 0.25)}
# for i in range(9):
vmax=60
for label in labelaxs:
    for i in range(10):
        tfplots = (dat_all[label][i] /
                   (np.std(dat_all[label],0) /
                    np.sqrt(len(dat_all[label]))))
        # rec_axs.append(fig.add_axes([0.05+(0.005*i), 0.27-(0.005*i), 0.1, 0.1]))
        labelaxs[label].append(
            fig.add_axes([startcoords[label][0]+(0.005*i),
                          startcoords[label][1]-(0.005*i), 0.1, 0.12]))
        # tfplots = ((dat_all['recalled'][i]-np.mean(dat_all['recalled'], 0)) /
        #            (np.std(dat_all['recalled'],0) /
        #             np.sqrt(len(dat_all['recalled']))))
        # dat_all['recalled'][i]
        labelaxs[label][-1].imshow(
            tfplots, aspect='auto',
            origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
        labelaxs[label][-1].set_xticks([55, 119])
        labelaxs[label][-1].set_xticks([55, 119])
        labelaxs[label][-1].plot([40, 40], [0, 14], 'k-')
        labelaxs[label][-1].set_xticklabels([])
        labelaxs[label][-1].set_yticks([0, 4, 9, 13])
        labelaxs[label][-1].set_yticklabels([]) 
        if i==0:
            # labelaxs[label][-1].set_yticklabels([2, 7, 39, 200])
            labelaxs[label][-1].set_title(label, fontweight='bold')
        # else:
        #     labelaxs[label][-1].set_yticklabels([])        
    # labelaxs[label][-1].set_xticklabels([0.3, 1.6])
    arrow = labelaxs[label][-1].arrow(
        1.12, 0.5, 0.6, 0.6, transform=labelaxs[label][-1].transAxes, clip_on=False,
        width=0.02, head_width=0.12, color='k')
    arrow = labelaxs[label][-1].arrow(
        1.12, 0.5, 0.6, -0.6, transform=labelaxs[label][-1].transAxes, clip_on=False,
        width=0.02, head_width=0.12, color='k')






fig.subplots_adjust(left=0.08, bottom=0.05, right=0.98, top=0.94, wspace=0.,
                    hspace=1)
# plt.savefig('./figs/power_samplelists_recunrec_nolabels.pdf')
# fig.text(0.0, 0.45, r'A',  fontdict={'weight': 'bold', 'size': 'large'},
fig.text(0.01, 0.62, r'A',  fontdict={'weight': 'bold', 'size': 'large'},
                    horizontalalignment='left', verticalalignment='bottom')

# fig.text(0.0, 0.38, r'B',  fontdict={'weight': 'bold', 'size': 'large'},
fig.text(0.01, 0.57, r'B',  fontdict={'weight': 'bold', 'size': 'large'},
         horizontalalignment='left', verticalalignment='bottom')
# plt.savefig('./figs/power_samplelists_recunrec_labels.pdf')



















































# fig = plt.figure(figsize=(7, 6))
# #gs0 = gridspec.GridSpec(2, 3, height_ratios=[6, 4], width_ratios=[1, 3, 5], wspace=0.3)
# #gs0 = gridspec.GridSpec(2, 3, height_ratios=[6, 4], width_ratios=[2, 3, 5], wspace=0.3)
# # gs0 = gridspec.GridSpec(2, 3, height_ratios=[6, 4], width_ratios=[4, 2, 6], wspace=0.3)
# # gs0 = gridspec.GridSpec(2, 3, height_ratios=[6, 4], width_ratios=[1, 4, 11], wspace=1)
# # gs0 = gridspec.GridSpec(2, 3, height_ratios=[6, 4], width_ratios=[1, 5, 14], wspace=1)
# # gs0 = gridspec.GridSpec(3, 3, height_ratios=[3, 1, 4], width_ratios=[6, 1, 6], wspace=1)
# gs0 = gridspec.GridSpec(3, 2, height_ratios=[3, 2, 2], wspace=0.6)
# gs00 = gridspec.GridSpecFromSubplotSpec(2, 9, subplot_spec=gs0[0, :],
#                                         height_ratios=[6, 1],
#                                         wspace=0.2, hspace=1.5)

# # In [8]: procpow['recalled'][15, indices]
# # Out[8]: 
# # array([[1, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1,
# #         1, 1],
# #        [1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 1,
# #         0, 1]])
# # In [10]: procpow['recalled'][15, indices].mean(1)
# # Out[10]: array([0.875     , 0.45833333])
# # In [11]: procpow['recalled'][15, indices].sum(1)
# # Out[11]: array([21, 11])


# plotrow = 0
# axs1 = np.empty((2, 9), object)
# for dat, words, recalled, prediction in zip(
#         procpow['data'][15, indices], procpow['words'][15, indices],
#         procpow['recalled'][15, indices], procpow['prediction'][15, indices]):
#     for plotcol, serialpos in enumerate(
#             list(range(4)) + [None] + list(range(20, 24))):
#         if serialpos is None:
#             continue
#         #plotcol = serialpos
#         axs1[plotrow, plotcol] = plt.Subplot(fig, gs00[plotrow, plotcol])
#         freqplot = axs1[plotrow, plotcol].imshow(
#             dat[:, serialpos], aspect='auto',
#             origin='lower', cmap='bwr', vmin=minval, vmax=maxval)
#         axs1[plotrow, plotcol].set_title(words[serialpos].decode(),
#                                           fontdict=wrd_fmt[recalled[serialpos]])
#         axs1[plotrow, plotcol].set_xticks([55, 119])
#         axs1[plotrow, plotcol].plot([40, 40], [0, 14], 'k-')
#         axs1[plotrow+1][plotcol] = plt.Subplot(fig, gs00[plotrow+1, plotcol])
#         axs1[plotrow+1][plotcol].barh(0.2, prediction[serialpos]-0.5)
#         axs1[plotrow+1][plotcol].plot([0, 0], [-0.25, 0.66], 'k', clip_on=False)
#         axs1[plotrow+1][plotcol].set_xlim((-0.15, 0.15))
#         axs1[plotrow+1][plotcol].set_ylim((-0.24, 0.64))
#         axs1[plotrow+1][plotcol].set_xticks((-0.1, 0, 0.1))
#         axs1[plotrow+1][plotcol].set_yticks([])
#         axs1[plotrow, plotcol].set_xticklabels([0.3, 1.6])
#         axs1[plotrow, plotcol].set_yticks([0, 4, 9, 14])
#         axs1[plotrow+1][plotcol].set_xticklabels((0.4,'', 0.6))
#         if plotcol == 0:
#             axs1[plotrow, plotcol].set_ylabel('Frequency (Hz)', labelpad=0)
#             axs1[plotrow, plotcol].set_xlabel('Time (s)', labelpad=0)
#             # axs[plotrow, plotcol].set_yticklabels(np.round(procpow['data'].attrs['frequency'][[0, 4, 9, 14]]))
#             axs1[plotrow, plotcol].set_yticklabels([2, 7, 39, 200])
#             axs1[plotrow+1][plotcol].set_xlabel(r'$\hat{p}($recall$)$', labelpad=0)
#         else:
#             plt.setp(axs1[plotrow, plotcol].get_yticklabels(), visible=False)
#             # plt.setp(axs1[plotrow+1, plotcol].get_xticklabels(), visible=False)
#         #axs[2, plotcol].set_visible(False)
#     # plotrow += 3
# # axs1[0, 6].axis('off')
# # axs1[1, 6].axis('off')
# # axs1[2, 6].set_visible(False)
# # axs1[3, 6].axis('off')
# # axs1[4, 6].axis('off')

# for i in [0, 1]:
#     axs1[i, 4] = plt.Subplot(fig, gs00[i, 4])
#     axs1[i, 4].text(0.5, 0.5, '...',  fontdict={'weight': 'bold', 'size': 'xx-large'},
#                     horizontalalignment='center', verticalalignment='center',
#                     transform=axs1[i, 4].transAxes)
#     axs1[i, 4].axis('off')
# # ax_cb1 = fig.add_axes([0.92, 0.753, 0.06, 0.02])
# # ax_cb1 = fig.add_axes([0.92, 0.73, 0.06, 0.02])
# ax_cb1 = fig.add_axes([0.88, 0.64, 0.1, 0.02])
# norm = mpl.colors.Normalize(vmin=-maxval, vmax=maxval)
# cb = mpl.colorbar.ColorbarBase(ax_cb1, cmap=plt.cm.bwr, # label='t(131)',
#                                # norm=norm, ticks=range(-4, 5, 2),
#                                # norm=norm, ticks=range(-2, 3, 2),
#                                norm=norm, ticks=range(-3, 4, 3),
#                                ticklocation='bottom',
#                                orientation='horizontal')
# #ax_cb.set_title(cbtitle, size='large')
# ax_cb1.set_ylabel(cbtitle, rotation=0, labelpad=25, verticalalignment='center')
# ax_cb1.tick_params(axis='both', which='major', pad=2)
# # plt.savefig('./figs/power_samplelists.pdf')

# for ax in np.ravel(axs1):
#     if not ax is None:
#         print(ax)
#         fig.add_subplot(ax)

# vmax = 12
# # fig, axs = plt.subplots(2, 1, sharex=True, sharey=True, figsize=(1, 2))
# axs2 = np.empty((1, 4), object)
# gs01 = gridspec.GridSpecFromSubplotSpec(1, 4, subplot_spec=gs0[1, :],
#                                         # width_ratios=[7, 7, 7, 7, 5, 4, 4, 4],
#                                         wspace=0.6, hspace=0.2)
# axs2[0, 1] = plt.Subplot(fig, gs01[0, 1])
# axs2[0, 1].imshow(tvals['all']['unrecalled'], aspect='auto',
#                   origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
# axs2[0, 3] = plt.Subplot(fig, gs01[0, 3])
# axs2[0, 3].imshow(tvals['all']['recalled'], aspect='auto',
#                   origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
# axs2[0, 1].set_yticks([0, 4, 9, 14])
# axs2[0, 3].set_yticks([0, 4, 9, 14])
# # axs[plotrow, plotcol].set_yticklabels(np.round(procpow['data'].attrs['frequency'][[0, 4, 9, 14]]))
# axs2[0, 1].set_yticklabels([2, 7, 39, 200])
# axs2[0, 3].set_yticklabels([2, 7, 39, 200])
# axs2[0, 1].set_ylabel('Frequency (Hz)', labelpad=0)
# axs2[0, 3].set_ylabel('Frequency (Hz)', labelpad=0)
# axs2[0, 1].set_xticks([55, 119])
# axs2[0, 1].plot([40, 40], [0, 14], 'k-')
# axs2[0, 3].set_xticks([55, 119])
# axs2[0, 3].plot([40, 40], [0, 14], 'k-')
# #plt.setp(axs2[0, 1].get_xticklabels(), visible=False)
# axs2[0, 1].set_xticklabels([0.3, 1.6])
# axs2[0, 3].set_xticklabels([0.3, 1.6])
# axs2[0, 1].set_xlabel('Time (s)', labelpad=0)
# axs2[0, 3].set_xlabel('Time (s)', labelpad=0)
# # ax_cb2 = fig.add_axes([0.05, 0.03, 0.06, 0.02])
# # ax_cb2 = fig.add_axes([0.35, 0.405, 0.06, 0.02])
# # # ax_cb2 = fig.add_axes([0.24, 0.03, 0.06, 0.02])
# # norm = mpl.colors.Normalize(vmin=-vmax, vmax=vmax)
# # cb = mpl.colorbar.ColorbarBase(ax_cb2, cmap=plt.cm.bwr, # label='t(131)',
# #                                # norm=norm, ticks=range(-4, 5, 2),
# #                                # norm=norm, ticks=range(-5, 6, 5),
# #                                norm=norm, ticks=range(-9, 10, 9),
# #                                ticklocation='bottom',
# #                                orientation='horizontal')
# # #ax_cb.set_title(cbtitle, size='large')
# # ax_cb2.set_ylabel(r'$t(96)$', rotation=0, labelpad=15, verticalalignment='center')
# # ax_cb2.tick_params(axis='both', which='major', pad=2)

# axs2[0, 1].annotate('', xy=(87, -7), xytext=(87, -16), ha='center',
#                     va='center', size=21, arrowprops=dict(
#                         arrowstyle='-[', shrinkA=0.5, shrinkB=5,
#                         fc="k", ec="k",
#                         connectionstyle="arc3,rad=0.0"),
#                     annotation_clip=False)

# axs2[0, 3].annotate('', xy=(87, -7), xytext=(87, -16), ha='center',
#                     va='center', size=21, arrowprops=dict(
#                         arrowstyle='-[', shrinkA=5, shrinkB=5,
#                         fc="k", ec="k",
#                         connectionstyle="arc3,rad=0.0"),
#                     annotation_clip=False)

# for ax in np.ravel(axs2):
#     if not ax is None:
#         print(ax)
#         fig.add_subplot(ax)


# vmax = 12
# # fig, axs = plt.subplots(2, 1, sharex=True, sharey=True, figsize=(1, 2))
# axs3 = np.empty((1, 4), object)
# gs02 = gridspec.GridSpecFromSubplotSpec(1, 4, subplot_spec=gs0[2, :],
#                                         width_ratios=[8, 3, 8, 3],
#                                         wspace=0.6, hspace=0.2)
# axs3[0, 1] = plt.Subplot(fig, gs02[0, 1])
# axs3[0, 1].imshow(np.reshape(tvals['all']['unrecalled'][:, 55:].mean(1), (15, 1)), aspect=0.5,
#                   origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
# axs3[0, 3] = plt.Subplot(fig, gs02[0, 3])
# axs3[0, 3].imshow(np.reshape(tvals['all']['recalled'][:, 55:].mean(1), (15, 1)), aspect=0.5,
#                   origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
# axs3[0, 1].set_yticks([0, 4, 9, 14])
# axs3[0, 3].set_yticks([0, 4, 9, 14])
# # axs[plotrow, plotcol].set_yticklabels(np.round(procpow['data'].attrs['frequency'][[0, 4, 9, 14]]))
# axs3[0, 1].set_yticklabels([2, 7, 39, 200])
# axs3[0, 3].set_yticklabels([2, 7, 39, 200])
# axs3[0, 1].set_ylabel('Frequency (Hz)', labelpad=0)
# axs3[0, 3].set_ylabel('Frequency (Hz)', labelpad=0)
# axs3[0, 1].set_xticks([])
# # axs2[0, 1].plot([40, 40], [0, 14], 'k-')
# axs3[0, 3].set_xticks([])
# # axs2[0, 3].plot([40, 40], [0, 14], 'k-')
# #plt.setp(axs2[0, 1].get_xticklabels(), visible=False)
# # axs2[0, 1].set_xticklabels([0.3, 1.6])
# # axs2[0, 3].set_xticklabels([0.3, 1.6])
# # axs2[0, 1].set_xlabel('Time (s)', labelpad=0)
# # axs2[0, 3].set_xlabel('Time (s)', labelpad=0)
# # ax_cb2 = fig.add_axes([0.05, 0.03, 0.06, 0.02])
# # ax_cb2 = fig.add_axes([0.35, 0.405, 0.06, 0.02])
# # # ax_cb2 = fig.add_axes([0.24, 0.03, 0.06, 0.02])
# # norm = mpl.colors.Normalize(vmin=-vmax, vmax=vmax)
# # cb = mpl.colorbar.ColorbarBase(ax_cb2, cmap=plt.cm.bwr, # label='t(131)',
# #                                # norm=norm, ticks=range(-4, 5, 2),
# #                                # norm=norm, ticks=range(-5, 6, 5),
# #                                norm=norm, ticks=range(-9, 10, 9),
# #                                ticklocation='bottom',
# #                                orientation='horizontal')
# # #ax_cb.set_title(cbtitle, size='large')
# # ax_cb2.set_ylabel(r'$t(96)$', rotation=0, labelpad=15, verticalalignment='center')
# # ax_cb2.tick_params(axis='both', which='major', pad=2)


# for ax in np.ravel(axs3):
#     if not ax is None:
#         print(ax)
#         fig.add_subplot(ax)

# ax_cb2 = fig.add_axes([0.1, 0.07, 0.1, 0.02]) # [0.92, 0.753, 0.06, 0.02][0.13, 0.4, 0.06, 0.02]
# norm = mpl.colors.Normalize(vmin=-vmax, vmax=vmax)
# cb = mpl.colorbar.ColorbarBase(ax_cb2, cmap=plt.cm.bwr, # label='t(131)',
#                                # norm=norm, ticks=range(-4, 5, 2),
#                                # norm=norm, ticks=range(-5, 6, 5),
#                                norm=norm, ticks=range(-9, 10, 9),
#                                ticklocation='bottom',
#                                orientation='horizontal')
# # #ax_cb.set_title(cbtitle, size='large')
# ax_cb2.set_ylabel(r'$t(96)$', rotation=0, labelpad=15, verticalalignment='center')
# ax_cb2.tick_params(axis='both', which='major', pad=2)



# labelaxs = {'unrecalled': [], 'recalled': []}
# startcoords = {'unrecalled': (0.05, 0.25), 'recalled': (0.55, 0.25)}
# # for i in range(9):
# vmax=60
# for label in labelaxs:
#     for i in range(10):
#         tfplots = (dat_all[label][i] /
#                    (np.std(dat_all[label],0) /
#                     np.sqrt(len(dat_all[label]))))
#         # rec_axs.append(fig.add_axes([0.05+(0.005*i), 0.27-(0.005*i), 0.1, 0.1]))
#         labelaxs[label].append(
#             fig.add_axes([startcoords[label][0]+(0.005*i),
#                           startcoords[label][1]-(0.005*i), 0.1, 0.12]))
#         # tfplots = ((dat_all['recalled'][i]-np.mean(dat_all['recalled'], 0)) /
#         #            (np.std(dat_all['recalled'],0) /
#         #             np.sqrt(len(dat_all['recalled']))))
#         # dat_all['recalled'][i]
#         labelaxs[label][-1].imshow(
#             tfplots, aspect='auto',
#             origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
#         labelaxs[label][-1].set_xticks([55, 119])
#         labelaxs[label][-1].set_xticks([55, 119])
#         labelaxs[label][-1].plot([40, 40], [0, 14], 'k-')
#         labelaxs[label][-1].set_xticklabels([])
#         labelaxs[label][-1].set_yticks([0, 4, 9, 13])
#         labelaxs[label][-1].set_yticklabels([]) 
#         if i==0:
#             # labelaxs[label][-1].set_yticklabels([2, 7, 39, 200])
#             labelaxs[label][-1].set_title(label, fontweight='bold')
#         # else:
#         #     labelaxs[label][-1].set_yticklabels([])        
#     # labelaxs[label][-1].set_xticklabels([0.3, 1.6])
#     arrow = labelaxs[label][-1].arrow(
#         1.12, 0.5, 0.6, 0.6, transform=labelaxs[label][-1].transAxes, clip_on=False,
#         width=0.02, head_width=0.12, color='k')
#     arrow = labelaxs[label][-1].arrow(
#         1.12, 0.5, 0.6, -0.6, transform=labelaxs[label][-1].transAxes, clip_on=False,
#         width=0.02, head_width=0.12, color='k')






# fig.subplots_adjust(left=0.08, bottom=0.05, right=0.98, top=0.94, wspace=0.,
#                     hspace=1)
# # plt.savefig('./figs/power_samplelists_recunrec_nolabels.pdf')
# # fig.text(0.0, 0.45, r'A',  fontdict={'weight': 'bold', 'size': 'large'},
# fig.text(0.01, 0.62, r'A',  fontdict={'weight': 'bold', 'size': 'large'},
#                     horizontalalignment='left', verticalalignment='bottom')

# # fig.text(0.0, 0.38, r'B',  fontdict={'weight': 'bold', 'size': 'large'},
# fig.text(0.01, 0.57, r'B',  fontdict={'weight': 'bold', 'size': 'large'},
#          horizontalalignment='left', verticalalignment='bottom')
# # plt.savefig('./figs/power_samplelists_recunrec_labels.pdf')
























classifierfolder_name = 'itemLR_nestedXval'
# regressorfolder_name = 'ridge_nestedXval'
classifier_folder = (os.path.join(
    homedir, 'ltpFR2_classifiers/itemvar/',
    classifierfolder_name, 'hdf5_files'))


prec_serialpos = []
clffiles = np.sort(glob(os.path.join(
    classifier_folder, 'classifier_info_allfeat_LTP???.hdf5')))
for cf in clffiles:
    with h5py.File(cf, 'r') as clffile:
        prec_serialpos.append([np.mean(
            clffile['recalled'][clffile['events/serialpos'][()]==i])
                               for i in range(1,25)])
prec_serialpos = np.array(prec_serialpos)
prec_serialpos_M = rec_serialpos.mean(0)
prec_serialpos_SE = rec_serialpos.std(0, ddof=1)/np.sqrt(len(rec_serialpos))
prec_serialpos_CI = prec_serialpos_SE *sp.stats.t.ppf(0.975, len(prec_serialpos)-1)

serialpos_all = tvals['serialpos_all'][:, :, 55:].mean(2)
serialpos_recalled = tvals['serialpos_recalled'][:, :, 55:].mean(2)
serialpos_unrecalled = tvals['serialpos_unrecalled'][:, :, 55:].mean(2)
# serialpos_recalled_unrecalled = tvals['recalled-unrecalled']['serialpos'][:, :, 55:].mean(2)

fig, axs = plt.subplots(4, 24, figsize=(6, 4), sharey='row', sharex='col')
vmax=12
for i in range(24):
    axs[0, i].bar([0], prec_serialpos_M[i], yerr=prec_serialpos_CI[i], color='gray')
    axs[0, i].axes.set_axis_off()
    axs[1, i].imshow(np.reshape(serialpos_all[:, i], (15, 1)), aspect=0.5,
                     origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
    axs[2, i].imshow(np.reshape(serialpos_recalled[:, i], (15, 1)), aspect=0.5,
                     origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
    axs[3, i].imshow(
        np.reshape(serialpos_unrecalled[:, i], (15, 1)), aspect=0.5,
        origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
    axs[3, i].set_xticks([0])
    axs[3, i].set_xticklabels([i+1])
axs[0, 0].set_ylim((0.4, 0.8))
ax = axs[0, 0].secondary_yaxis('left')
ax.set_ylabel('$p($rec$)$\n')
for i in range(1,4):
    axs[i, 0].set_yticks([0, 4, 9, 14])
    axs[i, 0].set_yticklabels([2, 7, 39, 200])
axs[1, 0].set_ylabel('\nall')
axs[2, 0].set_ylabel('Frequency (Hz)\nrecalled')
axs[3, 0].set_ylabel('\nunrecalled')
axs[3, 11].set_xlabel('Serial position')

# ax_cb = fig.add_axes([0.07, 0.05, 0.07, 0.02]) # [0.92, 0.753, 0.06, 0.02][0.13, 0.4, 0.06, 0.02]
ax_cb = fig.add_axes([0.9, 0.96, 0.09, 0.02]) # [0.92, 0.753, 0.06, 0.02][0.13, 0.4, 0.06, 0.02]
norm = mpl.colors.Normalize(vmin=-vmax, vmax=vmax)
cb = mpl.colorbar.ColorbarBase(ax_cb, cmap=plt.cm.bwr, # label='t(131)',
                               # norm=norm, ticks=range(-4, 5, 2),
                               # norm=norm, ticks=range(-5, 6, 5),
                               norm=norm, ticks=range(-9, 10, 9),
                               ticklocation='bottom',
                               orientation='horizontal')

# #ax_cb.set_title(cbtitle, size='large')
ax_cb.set_ylabel(r'$t(96)$', rotation=0, labelpad=15, verticalalignment='center')
ax_cb.tick_params(axis='both', which='major', pad=2)

fig.subplots_adjust(left=0.12, bottom=0.11, right=0.999, top=0.98, wspace=0.2,
                    hspace=0.2)
plt.savefig('./figs/serialpos.pdf')




























indices = [3, 4]
# indices = [2, 4]
# indices = [17, 18]
fig = plt.figure(figsize=(9, 7))
#gs0 = gridspec.GridSpec(2, 3, height_ratios=[6, 4], width_ratios=[1, 3, 5], wspace=0.3)
#gs0 = gridspec.GridSpec(2, 3, height_ratios=[6, 4], width_ratios=[2, 3, 5], wspace=0.3)
# gs0 = gridspec.GridSpec(2, 3, height_ratios=[6, 4], width_ratios=[4, 2, 6], wspace=0.3)
# gs0 = gridspec.GridSpec(2, 3, height_ratios=[6, 4], width_ratios=[1, 4, 11], wspace=1)
gs0 = gridspec.GridSpec(2, 3, height_ratios=[6, 4], width_ratios=[1, 5, 14], wspace=1)
gs00 = gridspec.GridSpecFromSubplotSpec(5, 13, subplot_spec=gs0[0, :],
                                        height_ratios=[600, 100, 1, 600, 100],
                                        wspace=0.2, hspace=1.5)

# In [8]: procpow['recalled'][15, indices]
# Out[8]: 
# array([[1, 0, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 1, 1,
#         1, 1],
#        [1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1, 1,
#         0, 1]])
# In [10]: procpow['recalled'][15, indices].mean(1)
# Out[10]: array([0.875     , 0.45833333])
# In [11]: procpow['recalled'][15, indices].sum(1)
# Out[11]: array([21, 11])


plotrow = 0
axs1 = np.empty((5, 13), object)
for dat, words, recalled, prediction in zip(
        procpow['data'][15, indices], procpow['words'][15, indices],
        procpow['recalled'][15, indices], procpow['prediction'][15, indices]):
    for plotcol, serialpos in enumerate(
            list(range(6)) + [None] + list(range(18, 24))):
        if serialpos is None:
            continue
        #plotcol = serialpos
        axs1[plotrow, plotcol] = plt.Subplot(fig, gs00[plotrow, plotcol])
        freqplot = axs1[plotrow, plotcol].imshow(
            dat[:, serialpos], aspect='auto',
            origin='lower', cmap='bwr', vmin=minval, vmax=maxval)
        axs1[plotrow, plotcol].set_title(words[serialpos].decode(),
                                          fontdict=wrd_fmt[recalled[serialpos]])
        axs1[plotrow, plotcol].set_xticks([55, 119])
        axs1[plotrow, plotcol].plot([40, 40], [0, 14], 'k-')
        axs1[plotrow+1][plotcol] = plt.Subplot(fig, gs00[plotrow+1, plotcol])
        axs1[plotrow+1][plotcol].barh(0.2, prediction[serialpos]-0.5)
        axs1[plotrow+1][plotcol].set_xlim((-0.15, 0.15))
        axs1[plotrow+1][plotcol].set_xticks((-0.1, 0, 0.1))
        axs1[plotrow+1][plotcol].set_yticks([])
        axs1[plotrow, plotcol].set_xticklabels([0.3, 1.6])
        axs1[plotrow, plotcol].set_yticks([0, 4, 9, 14])
        axs1[plotrow+1][plotcol].set_xticklabels((0.4,'', 0.6))
        if plotcol == 0:
            axs1[plotrow, plotcol].set_ylabel('Frequency (Hz)', labelpad=0)
            axs1[plotrow, plotcol].set_xlabel('Time (s)', labelpad=0)
            # axs[plotrow, plotcol].set_yticklabels(np.round(procpow['data'].attrs['frequency'][[0, 4, 9, 14]]))
            axs1[plotrow, plotcol].set_yticklabels([2, 7, 39, 200])
            axs1[plotrow+1][plotcol].set_xlabel(r'$\hat{p}($recall$)$', labelpad=0)
        else:
            plt.setp(axs1[plotrow, plotcol].get_yticklabels(), visible=False)
            # plt.setp(axs1[plotrow+1, plotcol].get_xticklabels(), visible=False)
        #axs[2, plotcol].set_visible(False)
    plotrow += 3
# axs1[0, 6].axis('off')
# axs1[1, 6].axis('off')
# axs1[2, 6].set_visible(False)
# axs1[3, 6].axis('off')
# axs1[4, 6].axis('off')

for i in [0, 1, 3, 4]:
    axs1[i, 6] = plt.Subplot(fig, gs00[i, 6])
    axs1[i, 6].text(0.5, 0.5, '...',  fontdict={'weight': 'bold', 'size': 'xx-large'},
                    horizontalalignment='center', verticalalignment='center',
                    transform=axs1[i, 6].transAxes)
    axs1[i, 6].axis('off')
# ax_cb1 = fig.add_axes([0.92, 0.753, 0.06, 0.02])
ax_cb1 = fig.add_axes([0.92, 0.73, 0.06, 0.02])
norm = mpl.colors.Normalize(vmin=-maxval, vmax=maxval)
cb = mpl.colorbar.ColorbarBase(ax_cb1, cmap=plt.cm.bwr, # label='t(131)',
                               # norm=norm, ticks=range(-4, 5, 2),
                               # norm=norm, ticks=range(-2, 3, 2),
                               norm=norm, ticks=range(-3, 4, 3),
                               ticklocation='bottom',
                               orientation='horizontal')
#ax_cb.set_title(cbtitle, size='large')
ax_cb1.set_ylabel(cbtitle, rotation=0, labelpad=25, verticalalignment='center')
ax_cb1.tick_params(axis='both', which='major', pad=2)
# plt.savefig('./figs/power_samplelists.pdf')

for ax in np.ravel(axs1):
    if not ax is None:
        print(ax)
        fig.add_subplot(ax)

# axs2 = np.empty((3, 1), object)
# gs02 = gridspec.GridSpecFromSubplotSpec(3, 1, subplot_spec=gs0[1, 0],
#                                         wspace=0.2, hspace=0.2)

# for i, dv in enumerate(
#         ['recalled_logit', 'residuals_interlist', 'residuals_intersess']):
#     axs2[i, 0] = plt.Subplot(fig, gs02[i, 0])
#     N, bins, patches = axs2[i, 0].hist(
#         np.ravel(procpow[dv][np.isfinite(procpow[dv])]), bin_n, range=(-3, 3))
#     for bn, ptch  in zip(bins, patches):
#         if ((bn <= quantiles_thresh[dv][1]) or
#             ((bn > quantiles_thresh[dv][2]) and
#              (bn <= quantiles_thresh[dv][3]))):
#             ptch.set_facecolor(col1)
#         else:
#             ptch.set_facecolor(col2)
#     if i != 2:
#         plt.setp(axs2[i, 0].get_xticklabels(), visible=False)
# # axs2[2, 0].set_xlabel(r'(Residuals of) $p($rec$))$')
# axs2[0, 0].text(0.02, 0.8, r'logit$(p($rec$))$',  #fontdict={'weight': 'bold', 'size': 'xx-large'},
#                     horizontalalignment='left', verticalalignment='center',
#                     transform=axs2[0, 0].transAxes)
# axs2[1, 0].text(0.02, 0.8, r'interlist',  #fontdict={'weight': 'bold', 'size': 'xx-large'},
#                     horizontalalignment='left', verticalalignment='center',
#                     transform=axs2[1, 0].transAxes)
# axs2[2, 0].text(0.02, 0.8, r'intersession',  #fontdict={'weight': 'bold', 'size': 'xx-large'},
#                     horizontalalignment='left', verticalalignment='center',
#                     transform=axs2[2, 0].transAxes)
        
# for ax in np.ravel(axs2):
#     if not ax is None:
#         print(ax)
#         fig.add_subplot(ax)

# vmax = 7
vmax = 12
# fig, axs = plt.subplots(2, 1, sharex=True, sharey=True, figsize=(1, 2))
axs2 = np.empty((2, 1), object)
gs01 = gridspec.GridSpecFromSubplotSpec(2, 1, subplot_spec=gs0[1, 1],
                                        wspace=0.2, hspace=0.2)
axs2[0, 0] = plt.Subplot(fig, gs01[0, 0])
axs2[0, 0].imshow(tvals['recalled'], aspect='auto',
                  origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
axs2[1, 0] = plt.Subplot(fig, gs01[1, 0])
axs2[1, 0].imshow(tvals['unrecalled'], aspect='auto',
                  origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
axs2[0, 0].set_yticks([0, 4, 9, 14])
axs2[1, 0].set_yticks([0, 4, 9, 14])
# axs[plotrow, plotcol].set_yticklabels(np.round(procpow['data'].attrs['frequency'][[0, 4, 9, 14]]))
axs2[0, 0].set_yticklabels([2, 7, 39, 200])
axs2[1, 0].set_yticklabels([2, 7, 39, 200])
axs2[1, 0].set_ylabel('Frequency (Hz)', labelpad=0)
axs2[0, 0].set_xticks([55, 119])
axs2[0, 0].plot([40, 40], [0, 14], 'k-')
axs2[1, 0].set_xticks([55, 119])
axs2[1, 0].plot([40, 40], [0, 14], 'k-')
plt.setp(axs2[0, 0].get_xticklabels(), visible=False)
axs2[1, 0].set_xticklabels([0.3, 1.6])
axs2[1, 0].set_xlabel('Time (s)', labelpad=0)
# ax_cb2 = fig.add_axes([0.05, 0.03, 0.06, 0.02])
ax_cb2 = fig.add_axes([0.35, 0.405, 0.06, 0.02])
# ax_cb2 = fig.add_axes([0.24, 0.03, 0.06, 0.02])
norm = mpl.colors.Normalize(vmin=-vmax, vmax=vmax)
cb = mpl.colorbar.ColorbarBase(ax_cb2, cmap=plt.cm.bwr, # label='t(131)',
                               # norm=norm, ticks=range(-4, 5, 2),
                               # norm=norm, ticks=range(-5, 6, 5),
                               norm=norm, ticks=range(-9, 10, 9),
                               ticklocation='bottom',
                               orientation='horizontal')
#ax_cb.set_title(cbtitle, size='large')
ax_cb2.set_ylabel(r'$t(96)$', rotation=0, labelpad=15, verticalalignment='center')
ax_cb2.tick_params(axis='both', which='major', pad=2)


for ax in np.ravel(axs2):
    if not ax is None:
        print(ax)
        fig.add_subplot(ax)


# fig, axs = plt.subplots(3, 4, sharex=True, sharey=True, figsize=(5, 4))
axs3 = np.empty((3, 4), object)
gs03 = gridspec.GridSpecFromSubplotSpec(3, 4, subplot_spec=gs0[1, 2],
                                        wspace=0.2, hspace=0.2)

for i, dv in enumerate(
        ['recalled_logit', 'residuals_interlist', 'residuals_intersess']):
    for j in range(4):
        axs3[i, j] = plt.Subplot(fig, gs03[i, j])
        axs3[i, j].imshow(tvals[dv][str(j)], aspect='auto',
                          origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
        axs3[i, j].set_yticks([0, 4, 9, 13])
        axs3[i, j].set_xticks([55, 119])
        axs3[i, j].plot([40, 40], [0, 14], 'k-')
        # axs[plotrow, plotcol].set_yticklabels(np.round(procpow['data'].attrs['frequency'][[0, 4, 9, 14]]))
        axs3[i, j].set_yticklabels([2, 7, 39, 200])
        axs3[i, j].set_xticklabels([0.3, 1.6])
        if i != 2:
            plt.setp(axs3[i, j].get_xticklabels(), visible=False)
        if j != 0:
            plt.setp(axs3[i, j].get_yticklabels(), visible=False)
axs3[2, 0].set_ylabel('Frequency (Hz)', labelpad=0)
axs3[2, 0].set_xlabel('Time (s)', labelpad=0)
axs3[0, 0].text(-1.4, 0.5, r'$\mathbf{p(}$rec$\mathbf{)}$', rotation=45, fontweight='bold',
                transform=axs3[0, 0].transAxes, horizontalalignment='center',
                verticalalignment='center')
axs3[1, 0].text(-1.4, 0.5, r'interlist', rotation=45, fontweight='bold',
                transform=axs3[1, 0].transAxes, horizontalalignment='center',
                verticalalignment='center')
axs3[2, 0].text(-1.4, 0.5, r'intersession', rotation=45, fontweight='bold',
                transform=axs3[2, 0].transAxes, horizontalalignment='center',
                verticalalignment='center')
# # ax_cb3 = fig.add_axes([0.92, 0.03, 0.06, 0.02]) # [0.92, 0.753, 0.06, 0.02]
# ax_cb3 = fig.add_axes([0.92, 0.4, 0.06, 0.02]) # [0.92, 0.753, 0.06, 0.02][0.13, 0.4, 0.06, 0.02]
# ax_cb3 = fig.add_axes([0.49, 0.4, 0.06, 0.02]) # [0.92, 0.753, 0.06, 0.02][0.13, 0.4, 0.06, 0.02]
ax_cb3 = fig.add_axes([0.92, 0.42, 0.06, 0.02]) # [0.92, 0.753, 0.06, 0.02][0.13, 0.4, 0.06, 0.02]
norm = mpl.colors.Normalize(vmin=-vmax, vmax=vmax)
cb = mpl.colorbar.ColorbarBase(ax_cb3, cmap=plt.cm.bwr, # label='t(131)',
                               # norm=norm, ticks=range(-4, 5, 2),
                               # norm=norm, ticks=range(-5, 6, 5),
                               norm=norm, ticks=range(-9, 10, 9),
                               ticklocation='bottom',
                               orientation='horizontal')
# #ax_cb.set_title(cbtitle, size='large')
ax_cb3.set_ylabel(r'$t(96)$', rotation=0, labelpad=15, verticalalignment='center')
ax_cb3.tick_params(axis='both', which='major', pad=2)

ax_quartiles = fig.add_axes([0.59, 0.38, 0.39, 0.05])
mu = 0
variance = 1
sigma = np.sqrt(variance)
x = np.linspace(mu - 3*sigma, mu + 3*sigma, 1000)
y = stats.norm.pdf(x, mu, sigma)
ax_quartiles.plot(x, y, 'k')
ax_quartiles.fill_between(x[x<-0.67], y[x<-0.67], 0, color='0.8')
ax_quartiles.fill_between(x[(x>=-0.67) & (x<0)], y[(x>=-0.67) & (x<0)], 0, color='0.6')
ax_quartiles.fill_between(x[(x>=0) & (x<0.67)], y[(x>=0) & (x<0.67)], 0, color='0.4')
ax_quartiles.fill_between(x[x>=0.67], y[x>=0.67], 0, color='0.2')
ax_quartiles.set_xlim([-3,3])
ax_quartiles.axis('off')

for ax in np.ravel(axs3):
    if not ax is None:
        print(ax)
        fig.add_subplot(ax)



labelaxs = {'recalled': [], 'unrecalled': []}
startcoords = {'recalled': 0.28, 'unrecalled': 0.10}
# for i in range(9):
vmax=60
for label in labelaxs:
    for i in range(10):
        tfplots = (dat_all[label][i] /
                   (np.std(dat_all[label],0) /
                    np.sqrt(len(dat_all[label]))))
        # rec_axs.append(fig.add_axes([0.05+(0.005*i), 0.27-(0.005*i), 0.1, 0.1]))
        labelaxs[label].append(
            fig.add_axes([0.05+(0.005*i),
                          startcoords[label]-(0.005*i), 0.07, 0.07]))
        # tfplots = ((dat_all['recalled'][i]-np.mean(dat_all['recalled'], 0)) /
        #            (np.std(dat_all['recalled'],0) /
        #             np.sqrt(len(dat_all['recalled']))))
        # dat_all['recalled'][i]
        labelaxs[label][-1].imshow(
            tfplots, aspect='auto',
            origin='lower', cmap='bwr', vmin=-vmax, vmax=vmax)
        labelaxs[label][-1].set_xticks([55, 119])
        labelaxs[label][-1].set_xticks([55, 119])
        labelaxs[label][-1].plot([40, 40], [0, 14], 'k-')
        labelaxs[label][-1].set_xticklabels([])
        labelaxs[label][-1].set_yticks([0, 4, 9, 13])
        labelaxs[label][-1].set_yticklabels([]) 
        if i==0:
            # labelaxs[label][-1].set_yticklabels([2, 7, 39, 200])
            labelaxs[label][-1].set_title(label, fontweight='bold')
        # else:
        #     labelaxs[label][-1].set_yticklabels([])        
    # labelaxs[label][-1].set_xticklabels([0.3, 1.6])
    arrow = labelaxs[label][-1].arrow(
        1.12, 0.5, 0.3, 0, transform=labelaxs[label][-1].transAxes, clip_on=False,
        width=0.02, head_width=0.12, color='k')

# fig.subplots_adjust(left=0.06, bottom=0.052, right=0.98, top=0.97, wspace=0.2,
fig.subplots_adjust(left=0.06, bottom=0.052, right=0.98, top=0.97, wspace=0.2,
                    hspace=0.3)
# plt.savefig('./figs/power_samplelists_agg_nolabels.pdf')
# fig.text(0.0, 0.45, r'A',  fontdict={'weight': 'bold', 'size': 'large'},
fig.text(0.0, 0.43, r'A',  fontdict={'weight': 'bold', 'size': 'large'},
                    horizontalalignment='left', verticalalignment='bottom')

# fig.text(0.0, 0.38, r'B',  fontdict={'weight': 'bold', 'size': 'large'},
fig.text(0.0, 0.4, r'B',  fontdict={'weight': 'bold', 'size': 'large'},
                    horizontalalignment='left', verticalalignment='bottom')

# fig.text(0.33, 0.38, r'C',  fontdict={'weight': 'bold', 'size': 'large'},
fig.text(0.43, 0.4, r'C',  fontdict={'weight': 'bold', 'size': 'large'},
                    horizontalalignment='left', verticalalignment='bottom')
# fig.text(0.54, 0.38, r'D',  fontdict={'weight': 'bold', 'size': 'large'},
#                     horizontalalignment='left', verticalalignment='bottom')
# plt.savefig('./figs/power_samplelists_agg_labels.pdf')




