
import sys
import os
import numpy as np
# import cPickle as pickle
# import multiprocessing as mp
from exceptions import OSError
import h5py

# add to python path (for ptsa stuff)
rhino_mount = ''
# rhino_mount = '/home/ctw/fusemounts/rhino'
# sys.path.append(rhino_mount + '/home1/cweidema/lib/python')
sys.path.insert(0, rhino_mount + '/home1/cweidema/lib/python')
from ptsa.data.events import Events
from ptsa.data.rawbinwrapper import RawBinWrapper
from ptsa.wavelet import phase_pow_multi
from ptsa.data.timeseries import TimeSeries
from dimarray import Dim

fs = '' # filesystem for office computer
# fs = '/home/ctw/fusemounts/psweidct' # fs for cluster computers
# num_mp_procs = mp.cpu_count()
num_mp_procs = 0

# load some data
print "Loading data"
# evfile = os.path.join(fs+'/home/ctw/Christoph/Analyses/recog/',
#                       'theses_and_data/ltpFR/ltpFR_analyzedevs.npy')

evfile = os.path.join(rhino_mount +
                      '/home1/cweidema/Christoph/Analyses/LTP/ltpFR2/',
                      'data/ltpFR2_20171221_allevs.npy')
# evfile = os.path.join(rhino_mount +
#                       '/home1/cweidema/Christoph/Analyses/LTP/ltpFR2/',
#                       'data/ltpFR2_20171026_allevs.npy')
# evfile = os.path.join('/data1/home/cweidema/Christoph/Analyses/',
#                       'theses_and_data/ltpFR/ltpFR_20140721_allevs.npy')

ev = Events(np.load(evfile))
ev = ev[ev['type'] == 'WORD']

# remove badEventChannel field -- it's not needed and the container
# does not let it be used as a Dim:
ev['badEventChannel'] = None
ev = ev.add_fields(esrc=np.dtype(RawBinWrapper))
output_path = (
    rhino_mount +
    '/scratch/cweidema/LTP/ltpFR2/ltpFR2_preprocessed/pow15freq2_200hz/')
esrc = {}
# good_indices = np.ones(len(ev),np.bool)

bad_subjsess = {'LTP122': [3], 'LTP207': [1], 'LTP260': [1], 'LTP293': [4],
                'LTP304': [14], 'LTP342': [1], 'LTP344': [10], 'LTP355': [2]}

good_indices = np.zeros(len(ev), np.bool)
for subj in np.unique(ev['subject']):
    esrc[subj] = {}
    for sess in np.unique(ev[ev['subject'] == subj]['session']):
        print subj, sess
        indx = (ev['subject'] == subj) & (ev['session'] == sess)
        if subj in bad_subjsess:
            if sess in bad_subjsess[subj]:
                print 'Bad subj, sess:', subj, sess
                good_indices[indx] = False
                continue
        try:
            esrc[subj][sess] = RawBinWrapper(rhino_mount +
                                             ev[indx]['eegfile'][0])
            good_indices[indx] = True
            ev['esrc'][(ev['subject'] == subj) &
                       (ev['session'] == sess)] = esrc[subj][sess]
        except:
            print 'No EEG files for', subj, sess, ev[indx]['eegfile'][0]
            good_indices[indx] = False
ev = ev[good_indices]

# channels without those on neck & face:
channels = ['00' + str(c) for c in range(2, 8)]
channels.extend(['00' + str(c) for c in range(9, 10)])
channels.extend(['0' + str(c) for c in range(10, 14)])
channels.extend(['0' + str(c) for c in range(15, 17)])
channels.extend(['0' + str(c) for c in range(18, 21)])
channels.extend(['0' + str(c) for c in range(22, 25)])
channels.extend(['0' + str(c) for c in range(26, 32)])
channels.extend(['0' + str(c) for c in range(33, 43)])
channels.extend(['0' + str(c) for c in range(33, 43)])
channels.extend(['0' + str(c) for c in range(44, 48)])
channels.extend(['0' + str(c) for c in range(50, 56)])
channels.extend(['0' + str(c) for c in range(57, 63)])
channels.extend(['0' + str(c) for c in range(64, 68)])
channels.extend(['0' + str(c) for c in range(69, 73)])
channels.extend(['0' + str(c) for c in range(74, 81)])
channels.extend(['0' + str(c) for c in range(82, 88)])
channels.extend(['0' + str(c) for c in range(89, 94)])
channels.extend(['0' + str(c) for c in range(95, 99)])
channels.extend([str(c) for c in range(100, 107)])
channels.extend([str(c) for c in range(108, 113)])
channels.extend([str(c) for c in range(114, 119)])
# channels.extend([str(c) for c in range(122, 125)])
channels.extend([str(c) for c in range(121, 125)])
channels.extend(['129'])



start_time = -0.8
end_time = 1.6
buf = 1.2
# baseline = (-.6, -.4)
eeghz = 500.
powhz = 50.
# Log spaced from 2 Hz to 100Hz
# freqs = np.logspace(np.log10(2), np.log10(100), 12)
freqs = np.logspace(np.log10(2), np.log10(200), 15)

# def ztrans_pow(dat, baseline):
#     # ztrans the power
#     zmean = dat['time>=' + repr(baseline[0]), 'time<' +
#                 repr(baseline[1])].mean('time').mean('events')
#     zmean = np.repeat(zmean, len(dat['time']) * len(dat['events'])).reshape(
#         dat.shape)
#     # zstd = dat['time>='+repr(baseline[0]),'time<'+repr(baseline[1])].std(
#     #     'time').mean('events')
#     zstd = dat['time>=' + repr(baseline[0]), 'time<' +
#                repr(baseline[1])].mean(
#                    'time').std('events')
#     zstd = np.repeat(zstd, len(dat['time']) * len(dat['events'])).reshape(
#         dat.shape)
#     dat -= zmean
#     dat /= zstd
#     return(dat, zmean[:, 0, 0], zstd[:, 0, 0])

def proc_chan(subj, sess, chan):
    print 'Processing subject, session, channel: ', subj, sess, chan
    pdir = os.path.join(fs + output_path, subj, 'session_' + str(sess))
    pfile_path = os.path.join(pdir, 'pow_' + subj + '_' + str(sess) +
                              '_' + str(chan) + '.hdf5')
    if not os.path.exists(pdir):
        try:
            os.makedirs(pdir)
        except OSError, e:
            print '*** no worries ***', e
    elif os.path.exists(pfile_path):
        return
    try:
        pfile = h5py.File(pfile_path, 'w-', libver='latest')
    except:
        return
    dat = ev[(ev['subject'] == subj) & (ev['session'] == sess)].get_data(
        channels=chan, start_time=start_time, end_time=end_time,
        buffer_time=buf, eoffset='eegoffset', keep_buffer=True,
        eoffset_in_time=False)
    # set mean to zero to reduce edge effects / ringing in later
    # processing steps (base_range set to the entire time series):
    dat = dat.baseline_corrected([dat['time'].min(), dat['time'].max()])

    print "Calculating power values for channel", chan
    dat = phase_pow_multi(freqs, dat[0], to_return='power')
    # log transform before resampling as resampling might produce
    # negative values
    dat = np.log10(dat)

    print "Downsampling channel", chan
    dat = dat.resampled(powhz, num_mp_procs=4)
    # remove the buffer now that we have and calculated power and downsampled
    print "Removing buffer from channel", chan
    dat = dat.remove_buffer(buf)
    data = pfile.create_dataset('data', data=dat, compression="gzip",
                                compression_opts=9)
    data.attrs['buffer'] = buf
    data.attrs['subject'] = subj
    data.attrs['session'] = sess
    data.attrs['channel'] = chan
    data.attrs['samplerate'] = dat.samplerate
    data.attrs['exp'] = 'ltpFR2'
    data.dims[0].label = 'freqs'
    pfile['freqs'] = freqs
    data.dims.create_scale(pfile['freqs'], 'freqs')
    data.dims[0].attach_scale(pfile['freqs'])
    data.dims[2].label = 'time'
    pfile['time'] = dat['time']
    data.dims.create_scale(pfile['time'], 'time')
    data.dims[2].attach_scale(pfile['time'])
    events = dat['events']
    data.dims[1].label = 'events'
    for dtn in events.dtype.names:
        # print 'dtn',dtn, data['events'][dtn].dtype
        if events[dtn].dtype == np.object:
            # print(dtn + ' is object!')
            continue
        pfile['events/' + dtn] = events[dtn]
        data.dims.create_scale(pfile['events/' + dtn], dtn)
        data.dims[1].attach_scale(pfile['events/' + dtn])
    pfile.close()

if num_mp_procs > 0:
    import multiprocessing as mp
    po = mp.Pool(num_mp_procs)

res = []

for subj in np.unique(ev['subject']):
    for sess in np.unique(ev[ev['subject'] == subj]['session']): # sessions:
        # print 'About to submit subject, session',subj,sess
        # res.append(po.apply_async(proc_sess,[subj,sess]))
        for chan in channels:
            print 'About to submit subject, session, channel', subj, sess, chan
            if num_mp_procs > 0:
                res.append(po.apply_async(proc_chan, [subj, sess, chan]))
            else:
                res.append(proc_chan(subj, sess, chan))

if num_mp_procs > 0:
    po.close()

# track results
for i, r in enumerate(res):
    sys.stdout.write('%d ' % i)
    sys.stdout.flush()
    if r is None:
        continue
    else:
        r.get()
