
import sys
run_on_rhino = True
# run_on_rhino = False

if run_on_rhino:
    rhino_mount = ''
    num_mp_procs = 0
    sys.path.insert(
        0, '/home1/cweidema/src/ptsa_new/build/lib.linux-x86_64-2.7/')
else:
    rhino_mount = '/home/ctw/fusemounts/rhino'
    num_mp_procs = 0
    sys.path.insert(
        0, '/home/ctw/src/ptsa_new/build/lib.linux-x86_64-2.7/')


# sys.path.insert(0, rhino_mount + '/home/ctw/src/ptsa_new/build/lib.linux-x86_64-2.7/')
# sys.path.insert(0, '/home/ctw/src/ptsa_new/build/lib.linux-x86_64-2.7/')
# sys.path.insert(0, '/home/ctw/src/ptsa_new/build/lib.linux-x86_64-2.7/')

import numpy as np
from ptsa.data.filters.morlet import MorletWaveletFilter
from ptsa.data.readers import EEGReader
from ptsa.data.filters import MonopolarToBipolarMapper
from ptsa.data.filters import ResampleFilter
from ptsa.data.filters import ButterworthFilter
# from ptsa.data.readers.TalReader import TalReader
from ptsa.data.readers import TalReader
# from ptsa.data.readers.IndexReader import JsonIndexReader
from ptsa.data.readers import JsonIndexReader
from ptsa.data.readers import BaseEventReader
from ptsa.data.timeseries import TimeSeries
import h5py
from exceptions import OSError
import os
import mne
from glob import glob








# import sys
# import os
# import numpy as np
# # import cPickle as pickle
# # import multiprocessing as mp
# from exceptions import OSError
# import h5py

# # add to python path (for ptsa stuff)
# rhino_mount = ''
# # rhino_mount = '/home/ctw/fusemounts/rhino'
# # sys.path.append(rhino_mount + '/home1/cweidema/lib/python')
# sys.path.insert(0, rhino_mount + '/home1/cweidema/lib/python')
# from ptsa.data.events import Events
# from ptsa.data.rawbinwrapper import RawBinWrapper
# from ptsa.wavelet import phase_pow_multi
# from ptsa.data.timeseries import TimeSeries
# from dimarray import Dim

# fs = '' # filesystem for office computer
# # fs = '/home/ctw/fusemounts/psweidct' # fs for cluster computers
# # num_mp_procs = mp.cpu_count()
# num_mp_procs = 0

# # load some data
# print "Loading data"
# # evfile = os.path.join(fs+'/home/ctw/Christoph/Analyses/recog/',
# #                       'theses_and_data/ltpFR/ltpFR_analyzedevs.npy')

# evfile = os.path.join(rhino_mount +
#                       '/home1/cweidema/Christoph/Analyses/LTP/ltpFR2/',
#                       'data/ltpFR2_20171221_allevs.npy')
# # evfile = os.path.join(rhino_mount +
# #                       '/home1/cweidema/Christoph/Analyses/LTP/ltpFR2/',
# #                       'data/ltpFR2_20171026_allevs.npy')
# # evfile = os.path.join('/data1/home/cweidema/Christoph/Analyses/',
# #                       'theses_and_data/ltpFR/ltpFR_20140721_allevs.npy')

# ev = Events(np.load(evfile))
# ev = ev[ev['type'] == 'WORD']

# # remove badEventChannel field -- it's not needed and the container
# # does not let it be used as a Dim:
# ev['badEventChannel'] = None
# ev = ev.add_fields(esrc=np.dtype(RawBinWrapper))
output_path = (
    rhino_mount +
    '/scratch/cweidema/LTP/ltpFR2/ltpFR2_preprocessed/pow15freq2_200hz/')
# esrc = {}
# # good_indices = np.ones(len(ev),np.bool)


jr = JsonIndexReader(rhino_mount + '/protocols/ltp.json')
exp = 'ltpFR2'
evs = []

bad_subjsess_files = [
    rhino_mount+
    '/protocols/ltp/subjects/LTP326/experiments/ltpFR2/sessions/19/behavioral/current_processed/task_events.json']

for f in sorted(jr.aggregate_values('task_events', experiment=exp)):
    if f in bad_subjsess_files:
        continue
    tmpev = BaseEventReader(filename=f).read()
    if len(tmpev) == 0:
        continue
    # only use BioSemi events
    if tmpev['eegfile'][0].split('.')[-1] != 'bdf':
        continue
    else:
        # only use encoding events:
        tmpev = tmpev[tmpev['type'] == 'WORD']
        evs.append(tmpev)
evs = np.concatenate(evs)

evs['eegfile'] = np.array([rhino_mount+ef for ef in evs['eegfile']])





# bad_subjsess = {'LTP122': [3], 'LTP207': [1], 'LTP260': [1], 'LTP293': [4],
#                 'LTP304': [14], 'LTP342': [1], 'LTP344': [10], 'LTP355': [2]}

# good_indices = np.zeros(len(ev), np.bool)
# for subj in np.unique(ev['subject']):
#     esrc[subj] = {}
#     for sess in np.unique(ev[ev['subject'] == subj]['session']):
#         print subj, sess
#         indx = (ev['subject'] == subj) & (ev['session'] == sess)
#         if subj in bad_subjsess:
#             if sess in bad_subjsess[subj]:
#                 print 'Bad subj, sess:', subj, sess
#                 good_indices[indx] = False
#                 continue
#         try:
#             esrc[subj][sess] = RawBinWrapper(rhino_mount +
#                                              ev[indx]['eegfile'][0])
#             good_indices[indx] = True
#             ev['esrc'][(ev['subject'] == subj) &
#                        (ev['session'] == sess)] = esrc[subj][sess]
#         except:
#             print 'No EEG files for', subj, sess, ev[indx]['eegfile'][0]
#             good_indices[indx] = False
# ev = ev[good_indices]

# # channels without those on neck & face:
# channels = ['00' + str(c) for c in range(2, 8)]
# channels.extend(['00' + str(c) for c in range(9, 10)])
# channels.extend(['0' + str(c) for c in range(10, 14)])
# channels.extend(['0' + str(c) for c in range(15, 17)])
# channels.extend(['0' + str(c) for c in range(18, 21)])
# channels.extend(['0' + str(c) for c in range(22, 25)])
# channels.extend(['0' + str(c) for c in range(26, 32)])
# channels.extend(['0' + str(c) for c in range(33, 43)])
# channels.extend(['0' + str(c) for c in range(33, 43)])
# channels.extend(['0' + str(c) for c in range(44, 48)])
# channels.extend(['0' + str(c) for c in range(50, 56)])
# channels.extend(['0' + str(c) for c in range(57, 63)])
# channels.extend(['0' + str(c) for c in range(64, 68)])
# channels.extend(['0' + str(c) for c in range(69, 73)])
# channels.extend(['0' + str(c) for c in range(74, 81)])
# channels.extend(['0' + str(c) for c in range(82, 88)])
# channels.extend(['0' + str(c) for c in range(89, 94)])
# channels.extend(['0' + str(c) for c in range(95, 99)])
# channels.extend([str(c) for c in range(100, 107)])
# channels.extend([str(c) for c in range(108, 113)])
# channels.extend([str(c) for c in range(114, 119)])
# # channels.extend([str(c) for c in range(122, 125)])
# channels.extend([str(c) for c in range(121, 125)])
# channels.extend(['129'])

channels = ['A'+str(i) for i in range(1, 33)]
channels.extend(['B'+str(i) for i in range(1, 33)])
channels.extend(['C'+str(i) for i in range(1, 33)])
channels.extend(['D'+str(i) for i in range(1, 33)])

channels = np.array(channels)

start_time = -0.8
end_time = 1.6
buf_time = 1.2
# baseline = (-.6, -.4)
eeghz = 500.
powhz = 50.
# Log spaced from 2 Hz to 100Hz
# freqs = np.logspace(np.log10(2), np.log10(100), 12)
freqs = np.logspace(np.log10(2), np.log10(200), 15)

# def ztrans_pow(dat, baseline):
#     # ztrans the power
#     zmean = dat['time>=' + repr(baseline[0]), 'time<' +
#                 repr(baseline[1])].mean('time').mean('events')
#     zmean = np.repeat(zmean, len(dat['time']) * len(dat['events'])).reshape(
#         dat.shape)
#     # zstd = dat['time>='+repr(baseline[0]),'time<'+repr(baseline[1])].std(
#     #     'time').mean('events')
#     zstd = dat['time>=' + repr(baseline[0]), 'time<' +
#                repr(baseline[1])].mean(
#                    'time').std('events')
#     zstd = np.repeat(zstd, len(dat['time']) * len(dat['events'])).reshape(
#         dat.shape)
#     dat -= zmean
#     dat /= zstd
#     return(dat, zmean[:, 0, 0], zstd[:, 0, 0])

def get_raw_eeg(subj, sess):
    eegpath = (rhino_mount+'/protocols/ltp/subjects/'+subj+
               '/experiments/ltpFR2/sessions/'+str(sess)+
               '/ephys/current_processed/')
    sys = 'bio' if int(subj[-3:]) > 330 else 'egi'
    if sys == 'bio':
        eegfile = glob(eegpath+'*.bdf')
        if len(eegfile)!=1:
            return
        eegfile = eegfile[0]
        raw = mne.io.read_raw_edf(eegfile, eog=['EXG1', 'EXG2', 'EXG3', 'EXG4'], 
                                  misc=['EXG5', 'EXG6', 'EXG7', 'EXG8'], 
                                  stim_channel='Status', 
                                  montage='biosemi128', 
                                  preload=True) # needs to be true for 0.1Hz high-pass filter to work

    else:
        # for now catch this case -- different pipeline for EGI subjects!
        raise ValueError('EGI subject!')
        eegfile = (glob(eegpath+'*.2.raw') + glob(eegpath+'*.1.raw') +
                   glob(eegpath+'*.mff'))
        if len(eegfile)!=1:
            return
        eegfile = eegfile[0]
        raw = mne.io.read_raw_egi(eegfile, preload=True)
        raw.rename_channels({'E129': 'Cz'})
        raw.set_montage(mne.channels.read_montage('GSN-HydroCel-129'))
        raw.set_channel_types({'E8': 'eog', 'E25': 'eog', 'E126': 'eog',
                               'E127': 'eog', 'Cz': 'misc'})
        
    # get bad channels - new version
    badchanfile = glob(eegpath+'*_bad_chan.txt')
    if len(badchanfile) > 0:
        with open(badchanfile[0], 'r') as f:
            bad = [s.strip() for s in f.readlines()]
        raw.info['bads'] = bad
    # 0.1Hz high-pass filter
    raw.filter(l_freq=0.1, h_freq=None, method='iir', iir_params=None)
    return raw

def create_epoch(raw, events, start_time=start_time,
                 end_time=end_time, buf_time=buf_time):
    mne_events = np.zeros((len(events), 3), dtype=int)
    mne_events[:, 0] = events['eegoffset']
    ep = mne.Epochs(raw, mne_events, tmin=start_time-buf_time,
                    tmax=end_time+buf_time, baseline=None, preload=True)
    # convert to microvolts, average reference
    ep._data = ep._data * 1000000
    ep.set_eeg_reference('average', projection=False)

    ep.pick_types(eeg=True, exclude=[])
    # # - resample
    # ep.resample(500.0)
    return ep




def proc_sess(subj, sess, chan, evs, dat):
    print 'Processing subject, session, channel: ', subj, sess, chan
    pdir = os.path.join(output_path, subj, 'session_' + str(sess))
    pfile_path = os.path.join(pdir, 'pow_' + subj + '_' + str(sess) +
                              '_' + str(chan) + '.hdf5')
    # # pdir = os.path.join(fs + output_path, subj, 'session_' + str(sess))
    # pdir = os.path.join(output_path, subj)
    # pfile_path = os.path.join(pdir, 'pow_' + subj + '_' + str(sess)+ '.hdf5')
    if not os.path.exists(pdir):
        try:
            os.makedirs(pdir)
        except OSError, e:
            print '*** no worries ***', e
    elif os.path.exists(pfile_path):
        return
    try:
        h5py.File(pfile_path+'.lock', 'w-', libver='latest')
    except:
        return
    # dat = EEGReader(events=evs.view(np.recarray), channels=[chan],
    #                 start_time=start_time,
    #                 end_time=end_time, buffer_time=buf).read()
    # set mean to zero to reduce edge effects / ringing in later
    # processing steps:
    dat -= dat.mean('time')
    dat = MorletWaveletFilter(
        timeseries=dat, freqs=freqs, output='power', width=5,
        verbose=True).filter()['power']
    dat = np.log10(dat)
    dat = ResampleFilter(dat, resamplerate=powhz).filter()
    dat = dat.remove_buffer(duration=buf_time)
    dat = dat.transpose('channels', 'frequency', 'events', 'time')
    dat.to_hdf(pfile_path, compression='gzip', compression_opts=9, mode='w-')
    os.remove(pfile_path+'.lock')
    
    # dat.to_hdf(pfile_path, compression='gzip', compression_opts=9)
    # dat = dat.transpose('channels', 'frequency', 'events', 'time')
    # data = pfile.create_dataset('data', data=dat, compression="gzip",
    #                             compression_opts=9)
    # data.attrs['buffer'] = buf
    # data.attrs['subject'] = str(subj)
    # data.attrs['session'] = sess
    # data.attrs['channel'] = chan
    # data.attrs['samplerate'] = dat.samplerate
    # data.attrs['exp'] = 'ltpFR2'
    # data.dims[0].label = 'channels'
    # pfile['channels'] = dat['channels']
    # data.dims.create_scale(pfile['channels'], 'channels')
    # data.dims[0].attach_scale(pfile['channels'])
    # data.dims[1].label = 'freqs'
    # pfile['freqs'] = freqs
    # data.dims.create_scale(pfile['freqs'], 'freqs')
    # data.dims[1].attach_scale(pfile['freqs'])
    # data.dims[3].label = 'time'
    # pfile['time'] = dat['time']
    # data.dims.create_scale(pfile['time'], 'time')
    # data.dims[3].attach_scale(pfile['time'])
    # events = dat['events']
    # data.dims[2].label = 'events'
    # for dtn in events.dtype.names:
    #     # print 'dtn',dtn, data['events'][dtn].dtype
    #     if events.values[dtn].dtype == np.object:
    #         # print(dtn + ' is object!')
    #         continue
    #     try:
    #         pfile['events/' + dtn] = events.values[dtn]
    #     except TypeError:
    #         pfile['events/' + dtn] = [str(ev) for ev in events.values[dtn]]
    #     data.dims.create_scale(pfile['events/' + dtn], dtn)
    #     data.dims[2].attach_scale(pfile['events/' + dtn])
    # pfile.close()








# def proc_chan(subj, sess, chan):
#     print 'Processing subject, session, channel: ', subj, sess, chan
#     pdir = os.path.join(fs + output_path, subj, 'session_' + str(sess))
#     pfile_path = os.path.join(pdir, 'pow_' + subj + '_' + str(sess) +
#                               '_' + str(chan) + '.hdf5')
#     if not os.path.exists(pdir):
#         try:
#             os.makedirs(pdir)
#         except OSError, e:
#             print '*** no worries ***', e
#     elif os.path.exists(pfile_path):
#         return
#     try:
#         pfile = h5py.File(pfile_path, 'w-', libver='latest')
#     except:
#         return
#     dat = ev[(ev['subject'] == subj) & (ev['session'] == sess)].get_data(
#         channels=chan, start_time=start_time, end_time=end_time,
#         buffer_time=buf, eoffset='eegoffset', keep_buffer=True,
#         eoffset_in_time=False)
#     # set mean to zero to reduce edge effects / ringing in later
#     # processing steps (base_range set to the entire time series):
#     dat = dat.baseline_corrected([dat['time'].min(), dat['time'].max()])

#     print "Calculating power values for channel", chan
#     dat = phase_pow_multi(freqs, dat[0], to_return='power')
#     # log transform before resampling as resampling might produce
#     # negative values
#     dat = np.log10(dat)

#     print "Downsampling channel", chan
#     dat = dat.resampled(powhz, num_mp_procs=4)
#     # remove the buffer now that we have and calculated power and downsampled
#     print "Removing buffer from channel", chan
#     dat = dat.remove_buffer(buf)
#     data = pfile.create_dataset('data', data=dat, compression="gzip",
#                                 compression_opts=9)
#     data.attrs['buffer'] = buf
#     data.attrs['subject'] = subj
#     data.attrs['session'] = sess
#     data.attrs['channel'] = chan
#     data.attrs['samplerate'] = dat.samplerate
#     data.attrs['exp'] = 'ltpFR2'
#     data.dims[0].label = 'freqs'
#     pfile['freqs'] = freqs
#     data.dims.create_scale(pfile['freqs'], 'freqs')
#     data.dims[0].attach_scale(pfile['freqs'])
#     data.dims[2].label = 'time'
#     pfile['time'] = dat['time']
#     data.dims.create_scale(pfile['time'], 'time')
#     data.dims[2].attach_scale(pfile['time'])
#     events = dat['events']
#     data.dims[1].label = 'events'
#     for dtn in events.dtype.names:
#         # print 'dtn',dtn, data['events'][dtn].dtype
#         if events[dtn].dtype == np.object:
#             # print(dtn + ' is object!')
#             continue
#         pfile['events/' + dtn] = events[dtn]
#         data.dims.create_scale(pfile['events/' + dtn], dtn)
#         data.dims[1].attach_scale(pfile['events/' + dtn])
#     pfile.close()

if num_mp_procs > 0:
    import multiprocessing as mp
    po = mp.Pool(num_mp_procs)

res = []


for subj in np.unique(evs['subject']):
    subjfilt = evs['subject'] == subj
    if int(subj[-3:]) < 331:
        continue
    for sess in np.unique(evs[subjfilt]['session']): # sessions:
        sessfilt = evs['session'] == sess
        
        pdir = os.path.join(output_path, subj, 'session_' + str(sess))
        # if os.path.exists(pdir):
        #     continue
        chanfiles = glob(os.path.join(pdir, 'pow_' + subj + '_' + str(sess) +
                                      '_*.hdf5'))
        if len(chanfiles) >= 128:
            continue
        dat = get_raw_eeg(subj, sess)
        if dat is None:
            continue
        dat = create_epoch(dat, events=evs[subjfilt & sessfilt],
                           start_time=start_time,
                           end_time=end_time, buf_time=buf_time)
        dat = TimeSeries(dat._data, dims=('events','channels','time'),
                         coords={'events': evs[subjfilt & sessfilt], 
                                 'channels': dat.info['ch_names'], 
                                 'time': dat.times,
                                 'samplerate': dat.info['sfreq']})
        for chan in channels:
            # res.append(po.apply_async(proc_sess,[subj,sess]))
            # for chan in channels:
            print 'About to submit subject, session, channel', subj, sess, chan
            if num_mp_procs > 0:
                res.append(po.apply_async(proc_sess,
                                          [subj, sess, chan,
                                           evs[subjfilt & sessfilt]], dat.sel(channels=[chan])))
            else:
                res.append(proc_sess(subj, sess, chan,
                                     evs[subjfilt & sessfilt], dat.sel(channels=[chan])))

# for subj in np.unique(ev['subject']):
#     for sess in np.unique(ev[ev['subject'] == subj]['session']): # sessions:
#         # print 'About to submit subject, session',subj,sess
#         # res.append(po.apply_async(proc_sess,[subj,sess]))
#         for chan in channels:
#             print 'About to submit subject, session, channel', subj, sess, chan
#             if num_mp_procs > 0:
#                 res.append(po.apply_async(proc_chan, [subj, sess, chan]))
#             else:
#                 res.append(proc_chan(subj, sess, chan))

if num_mp_procs > 0:
    po.close()

# track results
for i, r in enumerate(res):
    sys.stdout.write('%d ' % i)
    sys.stdout.flush()
    if r is None:
        continue
    else:
        r.get()
