import numpy as np
import os
import h5py
import numpy as np
from glob import glob
import io
import pickle
import h5py
run_on_rhino = True
# run_on_rhino = False
homedir = None
# homedir = '/media/ctw/intbkup1/rhino_eeg/LTP/ltpFR2'
# homedir = '/home/ctw/fusemounts/swan/media/ctw/intbkup1/rhino_eeg/LTP/ltpFR2'

if run_on_rhino:
    num_mp_procs = 0
    rhino_mount = ''
else:
    num_mp_procs = 0
    rhino_mount = '/home/ctw/fusemounts/rhino'
if homedir is None:
    homedir = rhino_mount+'/scratch/cweidema/LTP/ltpFR2'

rois = {'egi': {'LAI': ['023', '026', '027', '033', '034', '039', '040'],
                'LAS': ['012', '013', '019', '020', '024', '028', '029'],
                'RAI': ['002', '003', '109', '115', '116', '122', '123'],
                'RAS': ['004', '005', '111', '112', '117', '118', '124'],
                'LPI': ['051', '058', '059', '064', '065', '066', '069'],
                'LPS': ['037', '042', '052', '053', '054', '060', '061'],
                'RPI': ['084', '089', '090', '091', '095', '096', '097'],
                'RPS': ['078', '079', '085', '086', '087', '092', '093']},
        'biosemi': {'LAI': ['C27', 'C28', 'C31', 'C32', 'D5',  'D6',  'D10'],
                    'LAS': ['C24', 'C25', 'D2',  'D3',  'D4',  'D12', 'D13'],
                    'RAI': ['B29', 'C5',  'C6',  'C9',  'C10', 'C14', 'C15'],
                    'RAS': ['B31', 'B32', 'C2',  'C3',  'C4',  'C11', 'C12'],
                    'LPI': ['A8',  'A9',  'A16', 'A17', 'D26', 'D29', 'D30'],
                    'LPS': ['A5', ' A6',  'A7',  'A18', 'D16', 'D17', 'D28'],
                    'RPI': ['A29', 'A30', 'B5',  'B6',  'B12', 'B13', 'B16'],
                    'RPS': ['A31', 'A32', 'B2',  'B3',  'B4',  'B18', 'B19']}}


# # # homedir = rhino_mount+'/scratch/cweidema/LTP/ltpFR2'

powfolder_name = 'pow15freq2_200hz'
pow_folder = (os.path.join(
    homedir, 'ltpFR2_preprocessed/',
    powfolder_name))
classifierfolder_name = 'itemLR_nestedXval'
classifier_folder = (os.path.join(
    homedir, 'ltpFR2_classifiers/itemvar/',
    classifierfolder_name, 'hdf5_files'))
regressorfolder_name_itemvar = 'ridge_nestedXval_LR_pred_residuals_logit'
regressor_folder_itemvar = (os.path.join(
    homedir, 'ltpFR2_regressors/itemvar/',
    regressorfolder_name_itemvar, 'hdf5_files'))
regressorfolder_name_listvar = 'ridge_nestedXval_pred_residuals_catpredictors_logit'
regressor_folder_listvar = (os.path.join(
    homedir, 'ltpFR2_regressors/listvar/',
    regressorfolder_name_listvar, 'hdf5_files'))


# /scratch/cweidema/LTP/ltpFR2/ltpFR2_regressors/itemvar/ridge_nestedXval_LR_pred_residuals_logit/hdf5_files/
classifier_files = sorted(glob(os.path.join(
    classifier_folder, 'classifier_info_allfeat_LTP???.hdf5')))
regressor_files_itemvar = sorted(glob(os.path.join(
    regressor_folder_itemvar, 'regressor_info_allfeat_preds_residuals_LTP???.hdf5')))
assert(len(classifier_files) == len(regressor_files_itemvar))
regressor_files_listvar = sorted(glob(os.path.join(
    regressor_folder_listvar, 'regressor_info_allfeat_LTP???.hdf5')))
assert(len(classifier_files) == len(regressor_files_listvar))

powfiles = []
for cf, rf_itemvar, rf_listvar in zip(
        classifier_files, regressor_files_itemvar, regressor_files_listvar):
    subj = cf.split('_')[-1].split('.')[0]
    assert(subj == rf_itemvar.split('_')[-1].split('.')[0])
    assert(subj == rf_listvar.split('_')[-1].split('.')[0])
    powfiles.append(sorted(glob(os.path.join(
        pow_folder, subj, 'session_?/pow_' + subj +
        '_?_allchans.hdf5'))))
    powfiles[-1].extend(sorted(glob(os.path.join(
        pow_folder, subj, 'session_??/pow_' + subj +
        '_??_allchans.hdf5'))))
    assert(len(powfiles[-1]) <= 24)
    if len(powfiles[-1]) == 24:
        powfiles[-1].pop()    
    if powfiles[-1][-1].split('_')[-2] == '24':
        powfiles[-1].pop()
    elif (int(subj[-3:]) > 330) and (powfiles[-1][-1].split('_')[-2] == '23'):
        powfiles[-1].pop()

indices = range(24)
# all_lsts = {
#     'subject': [], 
#     'session': [], 
#     'dat': [], 
#     'dat_recalled': [], 
#     'dat_unrecalled': [], 
#     'words': [],
#     'recalled': [],
#     'prediction': [],
#     'recalled_logit': [],
#     'residuals_interlist': [],
#     'residuals_intersess': []
# }


processed_subjdat_folder = os.path.join(
    rhino_mount+'/scratch/cweidema/LTP/ltpFR2/ltpFR2_processed/subj_hdf5/')

str_keys = ['subject']
# conc_keys = ['data_recalled', 'data_unrecalled']

def make_processed_subjdat(subj_indx, powfiles_subj):
    subj = powfiles_subj[0].split('_')[-3]
    subjfilename = os.path.join(
        processed_subjdat_folder, subj+'_procpowdat.hdf5')
    if os.path.exists(subjfilename):
        return
    try:
        subjdat = h5py.File(subjfilename, 'x')
    except IOError:
        print('Cannot create', subjfilename)
        return
    print(subj)
    assert(subj in classifier_files[subj_indx])
    assert(subj in regressor_files_itemvar[subj_indx])
    assert(subj in regressor_files_listvar[subj_indx])
    clf = h5py.File(classifier_files[subj_indx], 'r')
    reg_itemvar = h5py.File(regressor_files_itemvar[subj_indx], 'r')
    reg_listvar = h5py.File(regressor_files_listvar[subj_indx], 'r')
    subj_lsts = {
        'subject': [],
        'session': [],
        'data': [],
        # 'data_recalled': [],
        # 'data_unrecalled': [],
        'words': [],
        'recalled': [],
        'prediction': [],
        'item_res_all': [],
        'item_res_norecallability': [],
        'item_res_noserialpos': [],
        'item_res_nosession': [],
        'item_res_nolist': [],
        'recalled_logit': [],
        'residuals_sesslist': [],
        'residuals_list': [],
        'residuals_sess': []
    }
    sess_indx = 0
    for powfile in powfiles_subj:
        pwr = h5py.File(powfile, 'r')
        # subj = pwr['coords/events']['subject'][0].decode()
        if 'events' in pwr.keys():
            evname = 'events'
            itemname = 'item'
            channame = 'channels'
            timename = 'time'
            freqname = 'freqs'
        else:
            evname = 'coords/events'
            itemname = 'item_name'
            channame = 'coords/channels'
            timename = 'coords/time'
            freqname = 'coords/frequency'
        session = pwr[evname]['session'][0]
        if session not in clf['events/session']:
            continue
        assert(session in reg_itemvar['events/session'])
        assert(session in reg_listvar['events/session'])
        if int(subj[-3:]) <= 330:
            session -= 1
        subj_lsts['subject'].append(subj)
        subj_lsts['session'].append(session)
        chan_fltr = np.array([((chan.decode() in rois['biosemi']['LPS']) or
                               (chan.decode() in rois['biosemi']['RPS']) or
                               (chan.decode() in rois['biosemi']['LAS']) or
                               (chan.decode() in rois['biosemi']['RAS']) or
                               (chan.decode() in rois['egi']['LPS']) or
                               (chan.decode() in rois['egi']['RPS']) or
                               (chan.decode() in rois['egi']['LAS']) or
                               (chan.decode() in rois['egi']['RAS']))
                              for chan in pwr[channame]])
        scale_means = np.mean(pwr['data'], 2)
        scale_std = np.std(pwr['data'], 2)
        sessdat = ((pwr['data']-scale_means[:, :, np.newaxis]) /
                   scale_std[:, :, np.newaxis])
        subj_lsts['data'].append(np.mean(
            [sessdat[chan_fltr, :, (i*24):(i+1)*24].squeeze()
             for i in indices], 1))
        subj_lsts['words'].append(
            [pwr[evname][itemname][(i*24):(i+1)*24] for i in indices])
        subj_lsts['recalled'].append(
            [pwr[evname]['recalled'][(i*24):(i+1)*24] for i in indices])
        subj_lsts['prediction'].append(
            [clf['prediction'][sess_indx][(i*24):(i+1)*24] for i in indices])
        subj_lsts['item_res_all'].append(
            reg_itemvar['residuals_logit_all'][(sess_indx*24):((sess_indx+1)*24)])
        subj_lsts['item_res_norecallability'].append(
            reg_itemvar['residuals_logit_norecallability'][(sess_indx*24):((sess_indx+1)*24)])
        subj_lsts['item_res_noserialpos'].append(
            reg_itemvar['residuals_logit_noserialpos'][(sess_indx*24):((sess_indx+1)*24)])
        subj_lsts['item_res_nosession'].append(
            reg_itemvar['residuals_logit_nosession'][(sess_indx*24):((sess_indx+1)*24)])
        subj_lsts['item_res_nolist'].append(
            reg_itemvar['residuals_logit_notrial'][(sess_indx*24):((sess_indx+1)*24)])
        subj_lsts['recalled_logit'].append(
            reg_listvar['recalled_logit'][(sess_indx*24):((sess_indx+1)*24)])
        subj_lsts['residuals_sesslist'].append(
            reg_listvar['residuals_sesslist'][(sess_indx*24):((sess_indx+1)*24)])
        subj_lsts['residuals_list'].append(
            reg_listvar['residuals_list'][(sess_indx*24):((sess_indx+1)*24)])
        subj_lsts['residuals_sess'].append(
            reg_listvar['residuals_sess'][(sess_indx*24):((sess_indx+1)*24)])
        # subj_lsts['data_recalled'].append(
        #     [dat[:, rec==1] for dat, rec in zip(subj_lsts['dat'][-1],
        #                                         subj_lsts['recalled'][-1])])
        # subj_lsts['data_unrecalled'].append(
        #     [dat[:, rec==0] for dat, rec in zip(subj_lsts['dat'][-1],
        #                                         subj_lsts['recalled'][-1])])
        sess_indx += 1
    for key in subj_lsts:
        if key in str_keys:
            subjdat.create_dataset(
                key, data=[bytes(strdat, 'utf-8')
                           for strdat in subj_lsts[key]],
                compression="gzip", compression_opts=9)
        # elif key in conc_keys:
        #     subjdat.create_dataset(
        #         key, data=np.concatenate([np.concatenate(concdat, 1)
        #                                    for concdat in subj_lsts[key]], 1),
        #         compression="gzip", compression_opts=9)
        else:
            subjdat.create_dataset(key, data=subj_lsts[key],
                                   compression="gzip", compression_opts=9)
    subjdat['data'].attrs['dimensions'] = ['session', 'list', 'frequency', 'item', 'time']
    subjdat['data'].attrs['time'] = pwr[timename]
    subjdat['data'].attrs['frequency'] = pwr[freqname]
    subjdat['prediction'].attrs['dimensions'] = ['session', 'list', 'item']
    subjdat['recalled'].attrs['dimensions'] = ['session', 'list', 'item']
    subjdat['item_res_all'].attrs['dimensions'] = ['session', 'list', 'item']
    subjdat['item_res_norecallability'].attrs['dimensions'] = ['session', 'list', 'item']
    subjdat['item_res_noserialpos'].attrs['dimensions'] = ['session', 'list', 'item']
    subjdat['item_res_nosession'].attrs['dimensions'] = ['session', 'list', 'item']
    subjdat['item_res_nolist'].attrs['dimensions'] = ['session', 'list', 'item']
    subjdat['words'].attrs['dimensions'] = ['session', 'list', 'item']
    subjdat['recalled_logit'].attrs['dimensions'] = ['session', 'list']
    subjdat['residuals_sesslist'].attrs['dimensions'] = ['session', 'list']
    subjdat['residuals_list'].attrs['dimensions'] = ['session', 'list']
    subjdat['residuals_sess'].attrs['dimensions'] = ['session', 'list']
    subjdat.close()


for subj_indx, powfiles_subj in enumerate(powfiles):
    make_processed_subjdat(subj_indx, powfiles_subj)



